package com.cesgroup.bdc.SelfDefinedGroup.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.cesgroup.bdc.SelfDefinedGroup.entity.SelfDefinedGroup;
import com.cesgroup.bdc.SelfDefinedGroup.mapper.SelfDefinedGroupMapper;
import com.cesgroup.bdc.SelfDefinedGroup.service.ISelfDefinedGroupService;
import com.cesgroup.bdc.SelfDefinedGroup.service.ISelfDefinedGroupUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 自定义组 服务实现类
 * </p>
 *
 * @author ChenKai
 * @since 2019-07-08
 */
@Service
public class SelfDefinedGroupServiceImpl extends ServiceImpl<SelfDefinedGroupMapper, SelfDefinedGroup> implements ISelfDefinedGroupService {
	@Autowired
	private ISelfDefinedGroupUserService selfDefinedGroupUserService;

	@Override
	public boolean removeByIds(String[] ids) {
		int i = ids.length;
		int j = 0;
		if (ids != null && ids.length > 0) {
			for (String id : ids
				) {
				boolean flag = this.removeById(id);
				if (flag) {
					j++;
				}
			}
		}
		if (i == j) {
			return true;
		}
		return false;
	}

	/**
	 * 获取某用户所有自定义组
	 *
	 * @param deptId
	 * @return
	 * @author: shen.shaohua
	 * @since: 2019/7/21 22:31
	 */
	public List<SelfDefinedGroup> getAll(String deptId) {
		List<SelfDefinedGroup> list = getBaseMapper().getAll(deptId);
		return list;
	}
}
