package com.cesgroup.bdc.apply.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.cesgroup.bdc.mail.entity.MailSend;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 延期申请
 * </p>
 *
 * @author shen.shaohua
 * @since 2019-07-17
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("EXPIRE_APPLY")
public class ExpireApply implements Serializable {
	private static final long serialVersionUID = -3846581269738258897L;

	@TableId("ID")
	private String id;

	/**
	 * 收文id
	 */
	@TableField("MAIL_RECEIVE_ID")
	private String mailReceiveId;

	/**
	 * 延期日期
	 */
	@TableField("EXPIRE_DATE")
	@JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
	@DateTimeFormat(pattern = "yyyy-MM-dd")
	private Date expireDate;

	/**
	 * 申请原因
	 */
	@TableField("APPLY_REASON")
	private String applyReason;

	/**
	 * 申请时间
	 */
	@TableField("APPLY_DATE")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	private Date applyDate;

	/**
	 * 申请人id
	 */
	@TableField("APPLY_USER_ID")
	private String applyUserId;

	/**
	 * 申请人名称
	 */
	@TableField("APPLY_USER_NAME")
	private String applyUserName;

	/**
	 * 申请部门id
	 */
	@TableField("APPLY_DEPT_ID")
	private String applyDeptId;

	/**
	 * 申请部门名称
	 */
	@TableField("APPLY_DEPT_NAME")
	private String applyDeptName;

	/**
	 * 审批人id
	 */
	@TableField("APPROVE_USER_ID")
	private String approveUserId;

	/**
	 * 审批人名称
	 */
	@TableField("APPROVE_USER_NAME")
	private String approveUserName;

	/**
	 * 审批部门id
	 */
	@TableField("APPROVE_DEPT_ID")
	private String approveDeptId;

	/**
	 * 审批部门名称
	 */
	@TableField("APPROVE_DEPT_NAME")
	private String approveDeptName;

	/**
	 * 审批结果（0：未审批，1：通过，2：不通过）
	 */
	@TableField("APPROVE_RESULT")
	private String approveResult;

	/**
	 * 审批内容
	 */
	@TableField("APPROVE_DETAIL")
	private String approveDetail;

	/**
	 * 审批时间
	 */
	@TableField("APPROVE_DATE")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	private Date approveDate;
	
	@TableField(exist = false)
	private MailSend mailSend;
}
