package com.cesgroup.bdc.apply.service.impl;

import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.cesgroup.bdc.apply.entity.ExpireApply;
import com.cesgroup.bdc.apply.entity.ExpireVo;
import com.cesgroup.bdc.apply.mapper.ExpireApplyMapper;
import com.cesgroup.bdc.apply.service.IExpireApplyService;
import com.cesgroup.bdc.mail.entity.MailReceive;
import com.cesgroup.bdc.util.CuiPage;
import com.cesgroup.bdc.wdgl.vo.ConditionVo;
import org.springframework.stereotype.Service;

import java.util.Map;

/**
 * <p>
 * 延期申请 服务实现类
 * </p>
 *
 * @author shen.shaohua
 * @since 2019-07-17
 */
@Service
public class ExpireApplyServiceImpl extends ServiceImpl<ExpireApplyMapper, ExpireApply> implements IExpireApplyService {
	/**
	 * 分页查询
	 *
	 * @param page
	 * @param cm
	 * @return
	 * @author: shen.shaohua
	 * @since: 2019/7/18 17:45
	 */
	public IPage<ExpireApply> queryPage(IPage<ExpireApply> page, Map<String, Object> cm) {
		IPage<ExpireApply> p = getBaseMapper().queryPage(page, cm);
		return p;
	}

	@Override
	public IPage<ExpireApply> queryPageList(CuiPage<ExpireApply> pager, ExpireVo expireVo) {
		expireVo = this.parseExpireVo(expireVo);
		IPage<ExpireApply> p = getBaseMapper().queryPageList(pager, expireVo);
		return p;
	}

	private ExpireVo parseExpireVo(ExpireVo expireVo) {
		if (StrUtil.isNotEmpty(expireVo.getApplyUserName())) {//申请人
			String s = escaped(expireVo.getApplyUserName());
			expireVo.setApplyUserName(s);
		}
		if (StrUtil.isNotEmpty(expireVo.getApplyDeptName())) {//申请部门
			String s = escaped(expireVo.getApplyDeptName());
			expireVo.setApplyDeptName(s);
		}
		if (StrUtil.isNotEmpty(expireVo.getMailTitle())) {//文电标题
			String s = escaped(expireVo.getMailTitle());
			expireVo.setMailTitle(s);
		}

		if (StrUtil.isNotEmpty(expireVo.getApproveUserName())) {//审批人
			String s = escaped(expireVo.getApproveUserName());
			expireVo.setApproveUserName(s);
		}


		return expireVo;
	}

	private String escaped(String s) {
		s = s.replace("/", "//").replace("_", "/_")
				.replace("%", "/%");
		s = "%" + s + "%";
		return s;
	}
}
