package com.cesgroup.bdc.attachment.dto;

import com.cesgroup.bdc.attachment.entity.Attachment;
import com.cesgroup.bdc.attachment.entity.DiskFile;
import com.cesgroup.bdc.attachment.entity.PrintNum;
import lombok.Data;

@Data
public class FileUploaderResponseDto {
	/**
	 * 文件id
	 */
	private String id;
	/**
	 * 源文件地址
	 */
	private String url;
	/**
	 * 所属模块
	 */
	private String module;
	/**
	 * 文件名称
	 */
	private String name;
	/**
	 * 文件大小
	 */
	private String size;
	/**
	 * 错误信息
	 */
	private String error;
	/**
	 * 文件类型
	 */
	private String type;


	private String ext;

	/**
	 * 打印次数
	 */
	private String printNum;

	public FileUploaderResponseDto() {
	}
	/**
	 * 文件标密
	 */
	private String securityLevelFile;

	public FileUploaderResponseDto(Attachment attachment, DiskFile diskFile) {
		this.setId(attachment.getId());
		this.setUrl(diskFile==null?"":diskFile.getFileName());
		this.setName(diskFile==null?"":diskFile.getOriginalName());
		this.setSize(diskFile==null?"":diskFile.getFileSize() + "");
		this.setModule(attachment.getModule());
		this.setType(diskFile==null?"":diskFile.getContentType());
		this.setExt(diskFile==null?"":diskFile.getExt());
		this.setSecurityLevelFile(attachment.getSecurityLevelFile());

	}

	public FileUploaderResponseDto(Attachment attachment, DiskFile diskFile, PrintNum printNum) {
		this.setId(attachment.getId());
		this.setUrl(diskFile==null?"":diskFile.getFileName());
		this.setName(diskFile==null?"":diskFile.getOriginalName());
		this.setSize(diskFile==null?"":diskFile.getFileSize() + "");
		this.setModule(attachment.getModule());
		this.setType(diskFile==null?"":diskFile.getContentType());
		this.setPrintNum(printNum.getPrintNumb());
		this.setExt(diskFile==null?"":diskFile.getExt());
		this.setSecurityLevelFile(attachment.getSecurityLevelFile());
	}
}
