package com.cesgroup.bdc.attachment.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.Date;

/**
 * <p>
 * 重打印申请表
 * </p>
 *
 * @author ChenKai
 * @since 2019-07-18
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("RE_PRINT_APPLY")
public class RePrintApply implements Serializable {
	private static final long serialVersionUID = 4381859594900310550L;

	/**
	 * 主键ID
	 */
	@TableId("ID")
	private String id;

	/**
	 * 申请人ID
	 */
	@TableField("APPLY_USER_ID")
	private String applyUserId;

	/**
	 * 申请人姓名
	 */
	@TableField("APPLY_USER_NAME")
	private String applyUserName;

	/**
	 * 申请部门ID
	 */
	@TableField("APPLY_DEPT_ID")
	private String applyDeptId;

	/**
	 * 申请部门名字
	 */
	@TableField("APPLY_DEPT_NAME")
	private String applyDeptName;

	/**
	 * 申请附件ID
	 */
	@TableField("RE_ATTACHMENT_ID")
	private String reAttachmentId;

	/**
	 * 申请附件名
	 */
	@TableField("RE_ATTACHMENT_NAME")
	private String reAttachmentName;

	/**
	 * 重打印分数
	 */
	@TableField("RE_PRINT_NUM")
	private String rePrintNum;

	/**
	 * 重打印原因
	 */
	@TableField("RE_PRINT_REASON")
	private String rePrintReason;

	/**
	 * 创建时间
	 */
	@TableField("CREATE_TIME")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	private Date createTime;

	/**
	 * 审批状态(0:待审批,1:审批通过,-1:审批没通过)
	 */
	@TableField("STATUS")
	private String status;

	/**
	 * 审批人ID
	 */
	@TableField("APPROVED_USER_ID")
	private String approvedUserId;

	/**
	 * 审批人名字
	 */
	@TableField("APPROVED_USER_NAME")
	private String approvedUserName;

	/**
	 * 审批时间
	 */
	@TableField("APPROVED_DATE")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	private Date approvedDate;

	/**
	 * 审批内容
	 */
	@TableField("APPROVED_TEXT")
	private String approvedText;

	/**
	 * 发送附件的部门ID
	 */
	@TableField("SEND_ATTACHMENT_DEPT_ID")
	private String sendAttachmentDeptId;

	/**
	 * 发送附件的部门名
	 */
	@TableField("SEND_ATTACHMENT_DEPT_NAME")
	private String sendAttachmentDeptName;

	/**
	 * 需要提交重新打印的收件ID
	 */
	@TableField("MAIL_RECEIVE_ID")
	private String mailReceiveId;

}
