package com.cesgroup.bdc.attachment.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.cesgroup.bdc.attachment.entity.Attachment;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;

import java.util.List;

/**
 * <p>
 * 附件 Mapper 接口
 * </p>
 *
 * @author shen.shaohua
 * @since 2019-07-02
 */
public interface AttachmentMapper extends BaseMapper<Attachment> {

	@Update("update attachment set relevance_id=#{relevanceId} where relevance_id=#{tempRelevanceId}")
	Integer updateTempRelevanceId(@Param("tempRelevanceId") String tempRelevanceId, @Param("relevanceId") String relevanceId);

	@Select("SELECT RELEVANCE_ID FROM ATTACHMENT WHERE ID=#{attachmentId}")
	String querySendDeptIdByAttachmentId(@Param("attachmentId") String attachmentId);

	/**
	 * @param module       附件关联模块
	 * @param originalName 文件名（格式：%文件名%）
	 * @param keyword      附件内容全文检索
	 * @return
	 * @author: shen.shaohua
	 * @since: 2019/7/23 13:43
	 */
	List<String> getRelevanceIds(@Param("module") String module,
															 @Param("originalName") String originalName,
															 @Param("keyword") String keyword);
}
