package com.cesgroup.bdc.attachment.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.cesgroup.bdc.attachment.dto.FileUploaderResponseDto;
import com.cesgroup.bdc.attachment.entity.Attachment;
import com.cesgroup.bdc.attachment.entity.DiskFile;
import com.cesgroup.kingkong.core.security.model.IOrganization;
import com.cesgroup.kingkong.core.security.model.IUser;
import org.springframework.web.multipart.MultipartFile;

import java.io.File;
import java.util.List;

/**
 * <p>
 * 附件 服务类
 * </p>
 *
 * @author shen.shaohua
 * @since 2019-07-02
 */
public interface IAttachmentService extends IService<Attachment> {
  List<FileUploaderResponseDto> saveMultiFile2(MultipartFile[] files, String module, String relevanceId,
                                               String relativePath, IUser uu, IOrganization org) throws Exception;

  /**
   * 删除附件
   *
   * @param id 文件关联ID
   */
  void deleteFile(String id);

  /**
   * 获得附件list
   *
   * @param module      类型
   * @param relevanceId 关联的id
   * @return
   */
  List<Attachment> selectByModuleAndRelevanceId(String module, String relevanceId);

  File getFileByAttachmentId(String attachmentId);

  File getFileByAttachment(Attachment attachment);

  File getFileByDiskFile(DiskFile diskFile);

  File getOfdFileByAttachment(Attachment attachment);

  File getOfdFileByDiskFile(DiskFile diskFile);

  /**
   * 替换临时关联id
   *
   * @param tempRelevanceId 临时关联id
   * @param relevanceId     关联id
   * @return
   */
  Integer updateTempRelevanceId(String tempRelevanceId, String relevanceId);

  /**
   * 根据原有的关联信息新增
   *
   * @param oldModule
   * @param oldRelevanceId
   * @param newModule
   * @param newRelevanceId
   */
  int addFromOld(String oldModule, String oldRelevanceId, String newModule, String newRelevanceId, IUser user, IOrganization org);

  /**
   * 删除附件
   *
   * @param module
   * @param relevanceId
   */
  void deleteByModuleAndRelevanceId(String module, String relevanceId);

  List<String> getRelevanceIds(String module, String keyword);

  void addNewOfd(Attachment attachment);

  File getFile(Attachment attachment);
}
