package com.cesgroup.bdc.auth.service;

import com.cesgroup.authen4.ws.CoreHttpClientWS;
import com.cesgroup.authen4.ws.entity.User;
import com.cesgroup.authen4.ws.entity.UserEx;
import com.cesgroup.kingkong.core.security.service.AuthsystemService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class AuthService {
  @Autowired
  private AuthsystemService authsystemService;

  /**
   * 租户id
   */
  private static final String TENANT_ID = "7fc3fbe6e2b342ddbcb06d101717f960";

  @Value("${kingkong.authsystem.url}")
  private String host;

  private CoreHttpClientWS coreHttpClientWS;

  private CoreHttpClientWS getCoreHttpClientWS() {
    if (coreHttpClientWS == null) {
      System.out.println("系统管理平台url===" + host);
      coreHttpClientWS = CoreHttpClientWS.getCoreHttpClientWS(host);
    }
    return coreHttpClientWS;
  }

  /**
   * 根据用户名查询用户
   *
   * @param userName
   * @return
   * @author: shen.shaohua
   * @since: 2019/10/1 17:16
   */
  public List<User> queryUserByName(String userName) {
    UserEx userEx = new UserEx();
    UserEx.Criteria criteria = userEx.createCriteria();
    criteria.andNameEqualTo(userName);
    List<User> users = getCoreHttpClientWS().queryUserByExample(userEx);
    return users;
  }

  public static void main(String[] args) {
    List<User> users = new AuthService().queryUserByName("吴小毛");
    System.out.println(users);
  }
}
