package com.cesgroup.bdc.filter;

import java.io.IOException;

import javax.servlet.*;
import javax.servlet.annotation.WebFilter;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.context.annotation.Configuration;

/**
 * 跨域请求设置。
 * @author khaoth
 */
@WebFilter(filterName = "crosDomFilter", urlPatterns = "/*")
@Configuration
public class CrosDomFilter implements Filter{

  @Override
  public void doFilter(ServletRequest req, ServletResponse resp, FilterChain chain) throws IOException, ServletException{

    HttpServletResponse httpResp = (HttpServletResponse)resp;
    HttpServletRequest httpReq = (HttpServletRequest)req;
    httpResp.setHeader("Access-Control-Allow-Origin", httpReq.getHeader("Origin"));
    httpResp.setHeader("Access-Control-Allow-Credentials", "true");
    chain.doFilter(req, resp);
  }

  @Override
  public void init(FilterConfig arg0) throws ServletException {}
  @Override
  public void destroy() {}

}
