package com.cesgroup.bdc.logs.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 登录日志
 * </p>
 *
 * @author shen.shaohua
 * @since 2019-07-24
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("LOGIN_LOG")
public class LoginLog implements Serializable {
	private static final long serialVersionUID = 1452610132157712445L;

	@TableField("ID")
	private String id;

	/**
	 * 登录人id
	 */
	@TableField("USER_ID")
	private String userId;

	/**
	 * 登录人名称
	 */
	@TableField("USER_NAME")
	private String userName;

	/**
	 * 登录部门id
	 */
	@TableField("DEPT_ID")
	private String deptId;

	/**
	 * 登录部门名称
	 */
	@TableField("DEPT_NAME")
	private String deptName;

	/**
	 * IP
	 */
	@TableField("IP")
	private String ip;

	/**
	 * 登录时间
	 */
	@TableField("LOGIN_TIME")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	private Date loginTime;

	/**
	 * 状态（0：失败，1：成功）
	 */
	@TableField("LOGIN_STATUS")
	private String loginStatus;

	/**
	 * 详细
	 */
	@TableField("LOG_DETAIL")
	private String logDetail;

}
