package com.cesgroup.bdc.mail.mapper;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.cesgroup.bdc.mail.entity.MailReceive;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.cesgroup.bdc.util.CuiPage;
import com.cesgroup.bdc.wdgl.vo.ConditionVo;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 收件信息 Mapper 接口
 * </p>
 *
 * @author shen.shaohua
 * @since 2019-07-08
 */
public interface MailReceiveMapper extends BaseMapper<MailReceive> {
    /**
     * 根据 ID 查询
     *
     * @param id 主键ID
     * @return
     * @author: shen.shaohua
     * @since: 2019/7/15 18:53
     */
    MailReceive getById(@Param("id") String id);

    List<Map<String, Object>> statistics(@Param("groupColumn") String groupColumn, @Param("cv") ConditionVo conditionVo);

    /**
     * 分页查询
     *
     * @param page
     * @param conditionVo
     * @return
     * @author: shen.shaohua
     * @since: 2019/7/15 18:53
     */
    IPage<MailReceive> queryPage(IPage<MailReceive> page, @Param("cv") ConditionVo conditionVo);

    /**
     * 查询
     *
     * @param conditionVo
     * @return
     * @author: shen.shaohua
     * @since: 2019/7/16 15:40
     */
    List<MailReceive> queryList(@Param("cv") ConditionVo conditionVo);

    IPage<MailReceive> queryReceiveListPage(CuiPage<MailReceive> pager, @Param("mailR") MailReceive mailReceive, @Param("today") Date today, @Param("mailTitle") String mailTitle, @Param("sendTimeStart") String sendTimeStart, @Param("sendTimeEnd") String sendTimeEnd);

    MailReceive queryReceiveFormById(@Param("bussinessId") String bussinessId);

    @Select("SELECT count(*) FROM (SELECT r.* FROM MAIL_RECEIVE r,MAIL_SEND s WHERE r.MAIL_SEND_ID=s.ID AND s.EFF_DATE > #{dateString} AND R.STATUS = '1' AND s.STATUS IN ('0','1') AND R.DEPT_ID=#{deptId})")
    int querReceiveCounts(@Param("deptId")String deptId,@Param("dateString")String dateString);
}
