package com.cesgroup.bdc.mail.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.cesgroup.bdc.mail.entity.MailReceive;
import com.baomidou.mybatisplus.extension.service.IService;
import com.cesgroup.bdc.util.CuiPage;
import com.cesgroup.bdc.wdgl.vo.ConditionVo;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 收件信息 服务类
 * </p>
 *
 * @author shen.shaohua
 * @since 2019-07-08
 */
public interface IMailReceiveService extends IService<MailReceive> {
	/**
	 * 根据状态查询
	 *
	 * @param sendId 发件id
	 * @param status 状态
	 * @return
	 */
	List<MailReceive> findBySendIdInStatus(String sendId, String... status);

	/**
	 * 根据发文id删除
	 *
	 * @param mailSendId
	 * @return
	 */
	boolean delByMailSendId(String mailSendId);

	/**
	 * 根据 ID 查询
	 *
	 * @param id
	 * @return
	 */
	MailReceive selectById(String id);

	/**
	 * 归类统计
	 *
	 * @param groupColumn 统计字段
	 * @param conditionVo 条件
	 * @return
	 */
	List<Map<String, Object>> statistics(String groupColumn, ConditionVo conditionVo);

	/**
	 * 分页查询
	 *
	 * @param page        分页
	 * @param conditionVo 查询条件
	 * @return
	 */
	IPage<MailReceive> queryPage(IPage<MailReceive> page, ConditionVo conditionVo);

	/**
	 * 查s询
	 *
	 * @param conditionVo 查询条件
	 * @return
	 */
	List<MailReceive> queryList(ConditionVo conditionVo);

	IPage<MailReceive> queryReceiveListPage(CuiPage<MailReceive> pager, MailReceive mailReceive,String mailTitle,String sendTimeStart,String sendTimeEnd);

	MailReceive queryReceiveFormById(String bussinessId);

	void updateMailSendStatus(String mailSendId);

    int querReceiveCounts(String deptId);
}
