package com.cesgroup.bdc.message.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.cesgroup.bdc.message.entity.MsgType;
import com.cesgroup.bdc.message.entity.NewMessages;
import com.cesgroup.bdc.message.service.INewMessagesService;
import com.cesgroup.kingkong.core.security.service.AuthsystemService;
import com.cesgroup.kingkong.web.BaseServiceController;
import com.cesgroup.kingkong.web.bind.annotation.KingkongRestController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 消息 前端控制器
 * </p>
 *
 * @author ChenKai
 * @since 2019-07-26
 */
@KingkongRestController
@RequestMapping("/new-messages")
public class NewMessagesController extends BaseServiceController<NewMessages, INewMessagesService> {

    @Autowired
    private AuthsystemService authsystemService;

    @RequestMapping("/getAllMessage")
    @ResponseBody
    public Map<String, Object> getAllMessage() {
        String userId = this.getUser().getId();
        String deptId = authsystemService.getOrganizationByUserId(userId).getId();
        Map<String, Object> retMap = new HashMap<>();
        QueryWrapper<NewMessages> newReceiveFile = new QueryWrapper<>();
        newReceiveFile.eq("MSG_NOTICE_DEPT_ID", deptId).eq("STATUS", "0");
        List<NewMessages> list = getBaseService().list(newReceiveFile);
        List<NewMessages> receiveList = new ArrayList<>();
        List<NewMessages> applyReprintList = new ArrayList<>();
        List<NewMessages> reprintResult = new ArrayList<>();
        List<NewMessages> applyOverDatetList = new ArrayList<>();
        List<NewMessages> overDateResult = new ArrayList<>();
        if (list.size() > 0 && !list.isEmpty()) {
            for (NewMessages messages : list
            ) {
                if (messages.getMsgType().equals(MsgType.RECEIVE_MSG.toString())) {//收件通知
                    receiveList.add(messages);
                } else if (messages.getMsgType().equals(MsgType.NEW_REPRINT_MSG.toString())) {//重打印审批通知
                    applyReprintList.add(messages);
                } else if (messages.getMsgType().equals(MsgType.NEW_OVERDATE_MSG.toString())) {//过期数据审批通知
                    applyOverDatetList.add(messages);
                } else if (messages.getMsgType().equals(MsgType.REPRINT_RESULT_MSG.toString()) && messages.getUserId().equals(userId)) {//重打印结果通知
                    reprintResult.add(messages);
                } else if (messages.getMsgType().equals(MsgType.OVERDATE_RESULT_MSG.toString()) && messages.getUserId().equals(userId)) {//过期数据结果通知
                    overDateResult.add(messages);
                }
            }
        }
        retMap.put("receiveList", receiveList);
        retMap.put("applyReprintList", applyReprintList);
        retMap.put("reprintResult", reprintResult);
        retMap.put("applyOverDatetList", applyOverDatetList);
        retMap.put("overDateResult", overDateResult);

        return retMap;
    }

    /**
     * @param msgType:点击的消息类型
     * @return boolean
     * @Author ChenKai
     * @Description 主页手动点击消息不再提示
     * @Date 2019-07-29 14:37
     */
    @GetMapping("/updateMessageStatus/{msgType}")
    public boolean updateMessageStatus(@PathVariable String msgType) {
        String userId = this.getUser().getId();
        String deptId = authsystemService.getOrganizationByUserId(userId).getId();
        UpdateWrapper<NewMessages> newReceiveFile = new UpdateWrapper<>();
        NewMessages messages=new NewMessages();
        messages.setStatus("1");
        if (msgType.equals("sjtz")) {//收件通知
            newReceiveFile.eq("MSG_NOTICE_DEPT_ID", deptId).eq("STATUS", "0").eq("MSG_TYPE", MsgType.RECEIVE_MSG.toString());
        } else if (msgType.equals("cdy_sp")) {//重打印申请通知
            newReceiveFile.eq("MSG_NOTICE_DEPT_ID",deptId).eq("STATUS", "0").eq("MSG_TYPE", MsgType.NEW_REPRINT_MSG.toString());
        } else if (msgType.equals("cdy_jg")) {//重打印审批结果通知
            newReceiveFile.eq("USER_ID",userId).eq("STATUS", "0").eq("MSG_TYPE", MsgType.REPRINT_RESULT_MSG.toString());
        } else if (msgType.equals("gqsj_sp")) {//过期数据申请通知
            newReceiveFile.eq("MSG_NOTICE_DEPT_ID",deptId).eq("STATUS", "0").eq("MSG_TYPE", MsgType.NEW_OVERDATE_MSG.toString());
        } else if (msgType.equals("gqsj_jg")) {//过期数据审批结果通知
            newReceiveFile.eq("USER_ID",userId).eq("STATUS", "0").eq("MSG_TYPE", MsgType.OVERDATE_RESULT_MSG.toString());
        }
    boolean flag = getBaseService().update(messages,newReceiveFile);

        return flag;
    }

}
