package com.cesgroup.bdc.message.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.cesgroup.bdc.message.entity.MsgType;
import com.cesgroup.bdc.message.entity.NewMessages;
import com.cesgroup.bdc.message.mapper.NewMessagesMapper;
import com.cesgroup.bdc.message.service.INewMessagesService;
import com.cesgroup.bdc.util.PrimaryKey;
import org.springframework.stereotype.Service;

/**
 * <p>
 * 消息 服务实现类
 * </p>
 *
 * @author ChenKai
 * @since 2019-07-26
 */
@Service
public class NewMessagesServiceImpl extends ServiceImpl<NewMessagesMapper, NewMessages> implements INewMessagesService {

    @Override
    public void addNewMessage(String msgDeptId,String userId,String fileId, MsgType msgType) {
        NewMessages messages=new NewMessages();
        messages.setId(PrimaryKey.generateId());
        messages.setMsgType(msgType.toString());
        messages.setUserId(userId);
        messages.setFileId(fileId);
        messages.setMsgNoticeDeptId(msgDeptId);
        messages.setStatus("0");
        getBaseMapper().insert(messages);
    }

    @Override
    public void updateMessageStatus(String deptId, String fileId, MsgType msgType) {
        NewMessages messages = new NewMessages();
        messages.setFileId(fileId);
        messages.setMsgNoticeDeptId(deptId);
        messages.setStatus("1");
        QueryWrapper<NewMessages> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("FILE_ID", fileId).eq("MSG_NOTICE_DEPT_ID", deptId).eq("STATUS", "0").eq("MSG_TYPE",msgType.toString());
        getBaseMapper().update(messages,queryWrapper);
    }
}
