package com.cesgroup.bdc.stamp.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Transient;
import java.io.Serializable;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @Auther:dxd
 * @Date:2022/9/14 15:40
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("STAMP")
public class Stamp implements Serializable {
    private static final long serialVersionUID = 6299940844558595606L;

    @TableId(value = "ID",type = IdType.ID_WORKER_STR)
    private String id;

    /**
     * 实例id
     */
    @TableField("PROCINSTID")
    private String procinstid;

    /**
     * 发文信息id
     */
    @TableField("MAIL_SEND_ID")
    private String mailSendId;

    /**
     * 申请时间时间
     */
    @TableField("SQ_TIME")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private Date sqTime;

    /**
     * 用章理由
     */
    @TableField("YZ_REASON")
    private String yzReason;

    /**
     * 申请人id
     */
    @TableField("APPLY_PERSON_ID")
    private String applyPersonId;

    /**
     * 申请人
     */
    @TableField("APPLY_PERSON_NAME")
    private String applyPersonName;

    /**
     * 申请部门id
     */
    @TableField("APPLY_DEPT_ID")
    private String applyDeptId;

    /**
     * 申请部门
     */
    @TableField("APPLY_DEPT_NAME")
    private String applyDeptName;

    /**
     * 标题
     */
    @TableField("MAIL_TITLE")
    private String mailTitle;

    /**
     * 用章参与部门
     */
    @TableField("YZ_DEPT")
    private String yzDept;

    /**
     * 状态
     */
    @TableField("STATUS")
    private String status;

    /**
     * 发文号
     */
    @TableField("MAIL_NO")
    private String mailNo;

    /**
     * 外单位ID
     */
    @TableField("WDW_DEPT_ID")
    private String wdwDeptId;

    /**
     * 类型
     */
    @TableField("TYPE")
    private String type;

    /**
     * 密级
     */
    @TableField("SAFE_LEVEL")
    private String safeLevel;

    /**
     * 密级
     */
    @TableField("SEAL_TYPE")
    private String sealType;

    /**
     * 电子文件名
     */
    @TableField(exist = false)
    private String file;

    /**
     * 工作流数据
     */
    @TableField(exist = false)
    private List<Map<String,Object>> list;

}
