package com.cesgroup.bdc.stamp.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import com.cesgroup.bdc.mail.entity.MailSend;
import com.cesgroup.bdc.stamp.entity.HisStamp;
import com.cesgroup.bdc.stamp.entity.Stamp;
import com.cesgroup.bdc.stamp.entity.StampStatus;
import com.cesgroup.bdc.stamp.entity.UseSealHisInfo;
import com.cesgroup.bdc.util.PageVo;
import com.cesgroup.bdc.wfself.entity.ProcInstHisInfo;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 发件信息 服务类
 * </p>
 *
 * @author shen.shaohua
 * @since 2019-07-08
 */
public interface IStampService extends IService<Stamp> {

    /**
     * 查询
     *
     * @param id
     * @return
     */
    Stamp selectOneStamp(String id);

    /**
     * 提交
     * @param entity
     * @return
     */
    Map<String, String> saveStamp(Stamp entity) throws Exception;
    /**
     * 申请人查询列表
     * @return
     */
    PageVo stampQueryApplyList(String sendTimeStart, String sendTimeEnd, String mailTitle, String status, String type, IPage<HisStamp> pager);

    /**
     * 根据执行任务id查询
     * @param execId
     * @return
     */
    HisStamp selectByExecId (String execId);

    /**
     * 处理用章流程
     * @param execId
     * @param reason
     * @param stamp
     * @throws Exception
     */
    void approve(String execId, String reason, Stamp stamp) throws Exception;

    /**
     * 根据历史表上个节点历史id和节点查询数据
     * @param hpId
     * @return
     */
    HisStamp selectByhpIdDwld(String hpId);

    /**
     * 根据上个节点历史id和节点查询数据
     * @param preNodeId
     * @return
     */
    HisStamp selectByhpIdApply(String preNodeId);

    /**
     * 根据实例id查询退回理由
     * @param procInstId
     * @return
     */
    List<Map<String, Object>> getReason(String procInstId);

    /**
     * 获取
     * @return
     */
    Integer getWdCount();

    Integer getYzCount();

    void deleteStampAndPHis(String stampId);

    void addUseSealHisInfo(UseSealHisInfo useSealHisInfo);

    void download(HttpServletRequest request, HttpServletResponse response);
}
