package com.cesgroup.bdc.util;

import com.baomidou.mybatisplus.core.metadata.IPage;
import lombok.Data;

import java.util.List;

@Data
public class PageVo<T> {
	/**
	 * 数据
	 */
	private List<T> data;
	/**
	 * 第几页
	 */
	private Long pageNumber;
	/**
	 * 每页条数
	 */
	private Long pageSize;
	/**
	 * 总条数
	 */
	private Long total;
	/**
	 * 总页数
	 */
	private Long totalPages;

	/**
	 * 转PageVo
	 *
	 * @param page 分页
	 */
	public static <R> PageVo<R> convertFromMybatisplusPage(IPage<R> page) {
		PageVo<R> result = new PageVo<>();
		if (page != null) {
			result.setData(page.getRecords());
			result.setPageSize(page.getSize());
			result.setPageNumber(page.getCurrent());
			result.setTotal(page.getTotal());
			result.setTotalPages(page.getPages());
		}
		return result;
	}
}
