package com.cesgroup.bdc.wdgl.vo;

import cn.hutool.json.JSONObject;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * 文电管理查询条件
 */
@Data
public class ConditionVo implements Serializable {
	private static final long serialVersionUID = -7278940954269058324L;

	/**
	 * 类型
	 */
	private String mailType;
	/**
	 * 密级
	 */
	private String safeLevel;
	/**
	 * 紧急度
	 */
	private String emergency;
	/**
	 * 有效时间-开始
	 */
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	private Date effDateBegin;
	/**
	 * 有效时间-结束
	 */
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	private Date effDateEnd;
	/**
	 * 发送时间-开始
	 */
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	private Date sendTimeBegin;
	/**
	 * 发送时间-结束
	 */
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	private Date sendTimeEnd;
	/**
	 * 电文状态
	 */
	private String mailStatus;
	/**
	 * 发送单位
	 */
	private String sendDept;
	/**
	 * 自动下载
	 */
	private String autoDownload;
	/**
	 * 发文号
	 */
	private String mailNo;
	/**
	 * 标题
	 */
	private String mailTitle;
	/**
	 * 签收时间-开始
	 */
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	private Date receiveDateBegin;
	/**
	 * 签收时间-结束
	 */
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	private Date receiveDateEnd;
	/**
	 * 接收单位
	 */
	private String receiveDept;
	/**
	 * 归类统计
	 */
	private String statistics;
	/**
	 * 附件全文检索
	 */
	private String fileKeyWord;

	/**
	 * 默认：查询本人，all：查询所有人
	 */
	private String flag;

	private String descs;
	private String ascs;
	private String order;

	private String receiveDeptId;
	private String sendUserId;
	private String originalName;//查询附件名时用

	@Override
	public String toString() {
		JSONObject jsonObject = new JSONObject(this);
		jsonObject.setDateFormat("yyyy-MM-dd HH:mm:ss");
		return jsonObject.toString();
	}

	public static void main(String[] args) {
		ConditionVo cv = new ConditionVo();
		cv.setAutoDownload("1");
		cv.setEmergency("平急");
		cv.setEffDateBegin(new Date());
		System.out.println(cv.toString());
	}
}
