package com.cesgroup.bdc.wfself.engine.service;

import java.util.Map;

/**
 * 流程任务service接口
 * 
 * @author khaoth
 *
 */
public interface ITaskService {

    /**
     * 签收
     * 
     * @param taskId
     *            任务id
     * @param userId
     *            签收用户id
     * @throws Exception
     */
    void sign(String taskId, String userId) throws Exception;

    /**
     * 完成当前任务，并流向下一个任务
     * 
     * @param taskId
     *            任务id
     * @param userId
     *            操作人id
     * 
     */
    void complete(String taskId, String userId) throws Exception;

    /**
     * 完成当前任务，并流向下一个任务
     * 
     * @param taskId
     *            任务id
     * @param userId
     *            操作人id
     * @param variableMap
     *            流程实例变量，如果当前流程实例变量存在相同的key，那么会替换已存在key的值
     */
    void complete(String taskId, String userId, Map<String, String> variableMap) throws Exception;

    /**
     * 撤回至上一个任务
     * 
     * @param taskId
     *            任务id
     * @param userId
     *            操作人id
     * 
     */
    void rollback(String taskId, String userId) throws Exception;

}
