package com.cesgroup.bdc.wfself.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;

/**
 * 历史流程实例信息
 * @author khaoth
 *
 */
@TableName("PROC_INST_HIS_INFO")
public class ProcInstHisInfo {

    /**
     * id
     */
    @TableId(value = "ID",type = IdType.UUID)
    private String id;
    
    /**
     * 流程实例id
     */
    @TableField("PROC_INST_ID")
    private String procInstId;
    
    /**
     * 流程定义id
     */
    @TableField("PROC_DEF_ID")
    private String procDefId;
    
    /**
     * 上一个节点id，如果是并行任务，存的是最后一个完成任务的id，
     * 如果由此节点做了退回操作，则此参数设置为空
     */
    @TableField("PRE_NODE_ID")
    private String preNodeId;
    
    /**
     * 流程节点code
     */
    @TableField("NODE_CODE")
    private String nodeCode;
    
    /**
     * 流程节点名称
     */
    @TableField("NODE_NAME")
    private String nodeName;
    
    /**
     * 执行id，可能是任务id，可能是后续其他节点的id
     */
    @TableField("EXEC_ID")
    private String execId;
    
    /**
     * 任务开始时间
     */
    @TableField("START_TIME")
    private String startTime;
    
    /**
     * 任务完成时间
     */
    @TableField("END_TIME")
    private String endTime;
    
    /**
     * 任务状态
     */
    @TableField("STATUS")
    private String status;
    
    /**
     * 受托人id
     */
    @TableField("ASSGINEE_ID")
    private String assgineeId;
    
    /**
     * 受托人名
     */
    @TableField("ASSGINEE_NAME")
    private String assgineeName;
    
    /**
     * 受托人组织id
     */
    @TableField("ASSGINEE_ORG_ID")
    private String assgineeOrgId;
    
    /**
     * 处理人id
     */
    @TableField("HANDLER_ID")
    private String handlerId;
    
    /**
     * 处理人名称
     */
    @TableField("HANDLER_NAME")
    private String handlerName;
    
    /**
     * 处理人组织id
     */
    @TableField("HANDLER_ORG_ID")
    private String handlerOrgId;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getProcInstId() {
        return procInstId;
    }

    public void setProcInstId(String procInstId) {
        this.procInstId = procInstId;
    }

    public String getProcDefId() {
        return procDefId;
    }

    public void setProcDefId(String procDefId) {
        this.procDefId = procDefId;
    }

    public String getPreNodeId() {
        return preNodeId;
    }

    public void setPreNodeId(String preNodeId) {
        this.preNodeId = preNodeId;
    }

    public String getNodeCode() {
        return nodeCode;
    }

    public void setNodeCode(String nodeCode) {
        this.nodeCode = nodeCode;
    }

    public String getNodeName() {
        return nodeName;
    }

    public void setNodeName(String nodeName) {
        this.nodeName = nodeName;
    }

    public String getExecId() {
        return execId;
    }

    public void setExecId(String execId) {
        this.execId = execId;
    }

    public String getStartTime() {
        return startTime;
    }

    public void setStartTime(String startTime) {
        this.startTime = startTime;
    }

    public String getEndTime() {
        return endTime;
    }

    public void setEndTime(String endTime) {
        this.endTime = endTime;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public String getAssgineeId() {
        return assgineeId;
    }

    public void setAssgineeId(String assgineeId) {
        this.assgineeId = assgineeId;
    }

    public String getAssgineeName() {
        return assgineeName;
    }

    public void setAssgineeName(String assgineeName) {
        this.assgineeName = assgineeName;
    }

    public String getAssgineeOrgId() {
        return assgineeOrgId;
    }

    public void setAssgineeOrgId(String assgineeOrgId) {
        this.assgineeOrgId = assgineeOrgId;
    }

    public String getHandlerId() {
        return handlerId;
    }

    public void setHandlerId(String handlerId) {
        this.handlerId = handlerId;
    }

    public String getHandlerName() {
        return handlerName;
    }

    public void setHandlerName(String handlerName) {
        this.handlerName = handlerName;
    }

    public String getHandlerOrgId() {
        return handlerOrgId;
    }

    public void setHandlerOrgId(String handlerOrgId) {
        this.handlerOrgId = handlerOrgId;
    }
}
