package com.cesgroup.bdc.wfself.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;

/**
 * 运行时任务信息
 * @author khaoth
 *
 */
@TableName("TASK_RUN_INFO")
public class TaskRunInfo {

    /**
     * 任务id
     */
    @TableId(value = "ID", type = IdType.UUID)
    private String id;
    
    /**
     * 流程实例id
     */
    @TableField("PROC_INST_ID")
    private String procInstId;
    
    /**
     * 流程定义id
     */
    @TableField("PROC_DEF_ID")
    private String procDefId;
    
    /**
     * 任务节点code
     */
    @TableField("TASK_CODE")
    private String taskCode;

    /**
     * 任务节点名称
     */
    @TableField("TASK_NAME")
    private String taskName;
    
    /**
     * 任务开始时间
     */
    @TableField("START_TIME")
    private String startTime;
    
    /**
     * 任务状态
     */
    @TableField("STATUS")
    private String status;
    
    /**
     * 受托人id
     */
    @TableField("ASSGINEE_ID")
    private String assgineeId;

    /**
     * 获取任务id
     * @return
     */
    public String getId() {
        return id;
    }

    /**
     * 设置任务id
     * @param id
     */
    public void setId(String id) {
        this.id = id;
    }

    /**
     * 获取流程实例id
     * @return
     */
    public String getProcInstId() {
        return procInstId;
    }

    /**
     * 设置流程实例id
     * @param procInstId
     */
    public void setProcInstId(String procInstId) {
        this.procInstId = procInstId;
    }

    /**
     * 获取流程定义id
     * @return
     */
    public String getProcDefId() {
        return procDefId;
    }

    /**
     * 设置流程定义id
     * @param procDefId
     */
    public void setProcDefId(String procDefId) {
        this.procDefId = procDefId;
    }

    /**
     * 获取任务节点code
     * @return
     */
    public String getTaskCode() {
        return taskCode;
    }

    /**
     * 设置任务节点code
     * @param taskCode
     */
    public void setTaskCode(String taskCode) {
        this.taskCode = taskCode;
    }

    /**
     * 获取任务节点名称
     * @return
     */
    public String getTaskName() {
        return taskName;
    }

    /**
     * 设置任务节点名称
     * @param taskName
     */
    public void setTaskName(String taskName) {
        this.taskName = taskName;
    }

    /**
     * 获取任务开始时间
     * @return
     */
    public String getStartTime() {
        return startTime;
    }

    /**
     * 设置任务开始时间
     * @param startTime
     */
    public void setStartTime(String startTime) {
        this.startTime = startTime;
    }

    /**
     * 获取任务状态
     * @return
     */
    public String getStatus() {
        return status;
    }

    /**
     * 设置任务状态
     * @param status
     */
    public void setStatus(String status) {
        this.status = status;
    }

    /**
     * 获取受托人id
     * @return
     */
    public String getAssgineeId() {
        return assgineeId;
    }

    /**
     * 设置受托人id
     * @param assgineeId
     */
    public void setAssgineeId(String assgineeId) {
        this.assgineeId = assgineeId;
    }
}
