package com.cesgroup.bdc.wfself.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;

/**
 * 运行时任务参与者
 * 
 * @author khaoth
 *
 */
@TableName("TASK_RUN_PARTIC")
public class TaskRunPartic {

    /**
     * 主键id
     */
    @TableId(value = "ID", type = IdType.UUID)
    private String id;

    /**
     * 流程实例id
     */
    @TableField("PROC_INST_ID")
    private String procInstId;

    /**
     * 参与者Id
     */
    @TableField("PARTIC_ID")
    private String particId;
    
    /**
     * 参与者type，有candidate，和assignee
     */
    @TableField("TYPE")
    private String type;
    
    /**
     * 参与者排序编号
     */
    @TableField("ORDER_NUM")
    private String orderNum;

    /**
     * 任务节点code
     */
    @TableField("TASK_CODE")
    private String taskCode;

    /**
     * 获取主键id
     * 
     * @return
     */
    public String getId() {
        return id;
    }

    /**
     * 设置主键id
     * 
     * @param id
     */
    public void setId(String id) {
        this.id = id;
    }

    /**
     * 获取流程实例id
     * @return
     */
    public String getProcInstId() {
        return procInstId;
    }

    /**
     * 设置流程实例id
     * @param procInstId
     */
    public void setProcInstId(String procInstId) {
        this.procInstId = procInstId;
    }

    /**
     * 获取参与者id
     * 
     * @return
     */
    public String getParticId() {
        return particId;
    }

    /**
     * 设置参与者id
     * 
     * @param particId
     */
    public void setParticId(String particId) {
        this.particId = particId;
    }

    /**
     * 获取参与者序号
     * @return
     */
    public String getOrderNum() {
        return orderNum;
    }

    /**
     * 设置参与者序号
     * @param orderNum
     */
    public void setOrderNum(String orderNum) {
        this.orderNum = orderNum;
    }

    /**
     * 获取参与人类型
     * @return
     */
    public String getType() {
        return type;
    }

    /**
     * 设置参与人类型
     * @param type
     */
    public void setType(String type) {
        this.type = type;
    }

    public String getTaskCode() {
        return taskCode;
    }

    public void setTaskCode(String taskCode) {
        this.taskCode = taskCode;
    }
}
