package com.cesgroup.bdc.wfself.node.gateway;

import com.cesgroup.bdc.wfself.def.CommonNode;
import com.cesgroup.bdc.wfself.def.IGateway;
import com.cesgroup.bdc.wfself.def.INode;

import java.util.List;

/**
 * 流程排他网关
 * 
 * @author khaoth
 */
public abstract class ExcluGateway extends CommonNode implements IGateway {

    public ExcluGateway() {}

    /**
     * 构造函数
     * 
     * @param code
     *            节点code
     * @param name
     *            节点名称
     */
    public ExcluGateway(String code, String name) {
        super(code, name);
    }
    
    /**
     * 网关流向判断。
     * 
     * 默认返回nodeList第一个值
     * 
     * @param param
     *            判断参数
     * @param nodeList
     *            流向的节点
     * @return
     */
    public abstract INode condition(String param, List<INode> nodeList);

}
