package com.cesgroup.bdc.wfself.node.task;

import com.cesgroup.bdc.wfself.def.CommonNode;
import com.cesgroup.bdc.wfself.def.ITask;

/**
 * 人工任务节点
 * 
 * @author khaoth
 */
public class UserTask extends CommonNode implements ITask {

    /**
     * 默认串行任务
     */
    private String jointSign = ITask.JOINT_SIGN_SERIAL;


    public UserTask() {}

    /**
     * 构造函数
     * 
     * @param code
     *            节点code
     * @param name
     *            节点名称
     */
    public UserTask(String code, String name) {
        super(code, name);
    }

    /**
     * 构造函数
     * 
     * @param code
     *            节点code
     * @param name
     *            节点名称
     * @param jointSign
     *            会签类型
     */
    public UserTask(String code, String name, String jointSign) {
        super(code, name);
        this.jointSign = jointSign;
    }


    /**
     * 获取会签类型
     * 
     * @return
     */
    public String getJointSign() {
        return jointSign;
    }

}
