<%@ page language="java" contentType="text/html;charset=UTF-8" pageEncoding="UTF-8" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="shiro" uri="http://shiro.apache.org/tags" %>
<%@ taglib prefix="cui" tagdir="/WEB-INF/tags" %>
<c:set var="ctx" value="${pageContext.request.contextPath}"/>
<%
    pageContext.setAttribute("idSuffix", String.valueOf(System.currentTimeMillis()).substring(6));
%>
<style>
    .readOnly {
        pointer-events: none;
        filter: alpha(opacity=50); /*IE滤镜，透明度50%*/
        -moz-opacity: 0.5; /*Firefox私有，透明度50%*/
        opacity: 0.5; /*其他，透明度50%*/
    }

    .form-table tr th {
        text-align: center;
    }
</style>
<cui:layout id="layout${idSuffix}" fit="true">
    <cui:layoutRegion region="center">
        <cui:form id="form${idSuffix}" heightStyle="fill" style="padding: 0px;">
            <!-- 原数据 -->
            <input type="hidden" name="id" id="id"/>
            <input type="hidden" name="canDownload" id="canDownload"/>
            <div style="width: 100%;margin: 0px auto;">
                <div class="form-wrap2" style="padding-right: 5px;width: 100%;">
                    <table class="form-table" cellpadding="0" cellspacing="0">

                        <tr>
                            <td colspan="10"
                                style="background-color: rgb(195,210,217);text-align: center;font-weight: bold;">属性相关
                            </td>
                            <td colspan="10"
                                style="background-color: rgb(195,210,217);text-align: center;font-weight: bold;">内容相关
                            </td>
                        </tr>
                        <tr>
                            <th colspan="3">文电类型</th>
                            <td id="mailType${idSuffix}" colspan="7"></td>
                            <%--<th colspan="3">发文号</th>
                            <td id="mailNo${idSuffix}" colspan="7"></td>--%>
                            <th colspan="3">标题</th>
                            <td id="mailTitle${idSuffix}" colspan="7"></td>
                        </tr>
                        <tr>
                            <th colspan="3">密级</th>
                            <td id="safeLevel${idSuffix}" colspan="7"></td>
                            <th rowspan="2 " colspan="3">正文</th>
                            <td rowspan="2" colspan="7">
                                <cui:textarea name="mailText" id="mailText${idSuffix}" componentCls="form-control"
                                              height="50" readonly="true"></cui:textarea>
                            </td>
                        </tr>
                        <tr>
                            <th colspan="3">紧急度</th>
                            <td id="emergency${idSuffix}" colspan="7"></td>

                        </tr>
                        <tr>
                            <th colspan="3">发送人</th>
                            <td id="userName" name="userName" colspan="7"></td>
                            <th colspan="3" rowspan="2" style="background-color: #feffef;">
                                附件
                            </th>
                            <td rowspan="2" colspan="7" style="padding: 0px; background-color: #feffef;">
                                <div id="fileList${idSuffix}"
                                     style="height: 77px;overflow: auto;background-color: #ffffff;margin: 5px;border: 1px solid #bdd0e6;">
                                        <%--<div style="height: 500px;width: 30px;background-color: red;"></div>--%>
                                </div>
                            </td>
                        </tr>
                        <tr>
                            <th colspan="3">有效时间</th>
                            <td id="effDate${idSuffix}" colspan="7"></td>

                        </tr>
                        <tr>
                            <th colspan="3">打印份数</th>
                            <td id="printNum${idSuffix}" colspan="7"></td>
                            <td colspan="10"
                                style="background-color: rgb(195,210,217);text-align: center;font-weight: bold;">签收回执
                            </td>
                        </tr>
                        <tr>
                            <th colspan="3">文电页数</th>
                            <td id="mailPage${idSuffix}" colspan="7"></td>
                            <th colspan="3">签收人</th>
                            <td id="receiveUserName${idSuffix}" colspan="7"></td>

                        </tr>

                        <tr>
                            <th colspan="3">发送时间</th>
                            <td id="sendTime${idSuffix}" colspan="7"></td>
                            <th rowspan="3" colspan="3">回执</th>
                            <td rowspan="3" colspan="7">
                                <cui:textarea name="replyText" id="replyText${idSuffix}" componentCls="form-control"
                                              height="50"></cui:textarea>
                            </td>

                        </tr>
                        <tr>
                            <th colspan="3">是否提供下载</th>
                            <td id="canDownload${idSuffix}" colspan="7"></td>

                        </tr>
                        <tr>
                            <th colspan="3">发送单位</th>
                            <td id="deptName${idSuffix}" colspan="7"></td>

                        </tr>

                    </table>
                </div>

            </div>
        </cui:form>
    </cui:layoutRegion>
    <cui:layoutRegion region="south" style="overflow: hidden;">
        <div class="buttens-foot-tools">
           <%-- <a onclick="mailReceive_edit_sample.printApply()" id="rePrintReply" class="readOnly">重打印申请</a>--%>
            <a onclick="mailReceive_edit_sample.toSign()" id="toSingButton">签收</a>
            <a onclick="mailReceive_edit_sample.colseD()">返回</a>
        </div>
    </cui:layoutRegion>
</cui:layout>
<cui:dialog id="dialogB${idSuffix}" modal="true" autoOpen="false" resizable="true"
            autoDestroy="false" reLoadOnOpen="false" maximized="false"></cui:dialog>
<cui:dialog id="dialogC${idSuffix}" modal="true" autoOpen="false" resizable="true"
            autoDestroy="true" reLoadOnOpen="true" maximized="false"></cui:dialog>
<cui:dialog id="dialogD${idSuffix}" modal="true" autoOpen="false" resizable="true"
            autoDestroy="true" reLoadOnOpen="true" maximized="false"></cui:dialog>
<cui:dialog id="dialogG${idSuffix}" modal="true" autoOpen="false" resizable="true"
            autoDestroy="true" reLoadOnOpen="true" maximized="false" ></cui:dialog>
<script type="text/javascript">
    var mailReceive_edit_fun = (function (win, $) {
        var bussinessId = '${id}';//收件id
        var mailSendId = '${mailSendId}'//发件id,也就是对应的附件attachment表的relevanceId

        function sample() {
        }

        var $thisDialog = $('#layout${idSuffix}').closest('.ctrl-init-dialog');
        var $form = $('#form${idSuffix}');

        $(function () {
            initLoad();
            reloadAttachment();
        });

        //加载
        function initLoad() {
            loading('加载中...');
            $.ajax({
                type: 'GET',
                url: '${ctx}/mail-receive/loadForm?bussinessId=' + bussinessId,
                dataType: 'json',
                success: function (data) {
                    hide();
                    if (data.status != 1) {
                        /* $("#toSingButton").attr("disabled", true);
                         $("#toSingButton").css("pointer-events", "none");*/
                        $("#toSingButton").remove();
                        $("#replyText${idSuffix}").textbox("option", "readonly", true);
                    }
                    $("#receiveUserName${idSuffix}").html(data.receiveUserName);
                    debugger;
                    $form.form('load', data.mailSend);
                    $form.form('load', data);
                    $("#userName").html(data.mailSend.userName);
                    for (var key in data.mailSend) {
                        var text = data.mailSend[key];
                        if (key == 'canDownload') {
                            if (text == '1') {
                                $("#canDownload").val(1);
                                text = '是';
                            } else if (text == '0') {
                                text = '否';
                            }

                        }
                        ;


                        $('#' + key + '${idSuffix}').html(text);
                    }
                },
                error: function (e) {
                    hide();
                    error(e);
                }
            });
        }

        //关闭
        sample.prototype.colseD = function () {
            closeThisDialog();
        }

        //签收
        sample.prototype.toSign = function () {
            var replyText = $("#replyText${idSuffix}").textbox("getValue");
            $.confirm('确认签收', function (r) {
                if (r) {
                    $.ajax({
                        type: 'GET',
                        url: '${ctx}/mail-receive/updateReplyStatus?bussinessId=' + bussinessId + '&mailSendId=' + mailSendId + '&replyText=' + replyText,
                        dataType: 'json',
                        success: function (data) {
                            if (data) {
                                mailReceive_list_sample.reloadGrid();
                                closeThisDialog();
                            }
                        }
                    });
                } else {


                }

            });
        }


        function closeThisDialog() {
            $thisDialog.dialog('close');
        }


        //加载附件
        function reloadAttachment() {
            $.ajax({
                type: 'GET',
                url: '${ctx}/print-num/findPrintMail?attachmentId=' + mailSendId + "&businessId=" + bussinessId,
                dataType: 'json',
                success: function (data) {
                    debugger;
                    //hide();
                    var hh = '';
                    $.each(data, function (i, item) {
                        debugger;
                        var securityLevelFileText = "";
                        if(item.securityLevelFile!=null){
                            securityLevelFileText = '('+item.securityLevelFile+')';
                        }
                        var securityLevel = "(无)";
                        if(!isEmpty($("#safeLevel${idSuffix}").text())){
                            securityLevel = '('+ $("#safeLevel${idSuffix}").text()+')';
                        }
                        var smName ="";
                        if(item.securityLevelFile!=null){
                            smName =securityLevelFileText;
                        }else {
                            smName =securityLevel;
                        }
                        if(item.ext=='zip'||item.ext=='rar'||item.ext=='ZIP'||item.ext=='RAR'||item.ext=='7z'){
                                hh += '<div class="fileItem" id="upload-' + item.id + '">' +
                                    '<a  href="${ctx}/attachment/downloadOriginal/'+item.id+'"    target="_blank">' + item.name +smName+ '</a></div>'
                        }else{
                            if (item.printNum > 0) {
                                hh += '<div class="fileItem" id="upload-' + item.id + '">' +
                                    '<a  onclick="mailReceive_edit_sample.printAttachment(\'' + item.id + '\',\'' + bussinessId + '\')"    target="_blank">' + item.name +smName+ '</a></div>'
                            } else {/*<span style="color:green"> 可打印次数:' + item.printNum + '</span>*/
                                $("#rePrintReply").removeClass("readOnly");//重打印申请
                                hh += '<div class="fileItem" id="upload-' + item.id + '">' +
                                    '<a  onclick="mailReceive_edit_sample.printAttachment(\'' + item.id + '\',\'' + bussinessId + '\')"    target="_blank">' + item.name +smName+ '</a><span style="color:red">附件不可打印</span></div>'
                            }
                        }

                    });
                    $('#fileList${idSuffix}').html(hh);
                },
                error: function (e) {
                    //hide();
                    error(e);
                }
            });
        }
        //判断字符是否为空的方法
        function isEmpty(obj) {
            if (typeof obj == "undefined" || obj == null || obj == "") {
                return true;
            } else {
                return false;
            }
        }
        //签收状况
        sample.prototype.qszkHandle = function () {
            var url = '${ctx}/mail-receive/viewList/' + bussinessId;
            $('#dialogC${idSuffix}').dialog('option', {
                url: url,
                title: '签收状况',
                asyncType: 'get',
                width: 730,
                height: 588,
                buttons: null
            }).dialog('open');
        }

//打印一次附件
        /*  sample.prototype.printAttachment = function (attachId, mailReceiveId) {
              $.ajax({
                  type: 'GET',
                  url: '
        ${ctx}/print-num/updatePrintNum?attachmentId=' + attachId + "&businessId=" + mailReceiveId,
                dataType: 'json',
                success: function (data) {
                    reloadAttachment();
                }
            })
        }*/

        sample.prototype.printAttachment = function (attachId, mailReceiveId) {
            var canDown=$("#canDownload").val();
            var url = '${ctx}/print-num/updatePrintNum2?attachmentId=' + attachId + "&businessId=" + mailReceiveId+"&canDownload="+canDown;
            window.open(url);
         /*   $('#dialogG${idSuffix}').dialog('option', {
                url: url,
                title: '打印',
                asyncType: 'get',
                width: '90%',
                height: '90%',
                buttons: null
            }).dialog('open');*/

        }

        sample.prototype.cxk=function(){
            reloadAttachment();
        }

        //重打印申请
        sample.prototype.printApply = function () {
            var url = '${ctx}/print-num/printAgainApply?receiveId=' + bussinessId + "&attachId=" + mailSendId;
            $('#dialogD${idSuffix}').dialog('option', {
                url: url,
                title: '重打印申请',
                asyncType: 'get',
                width: 530,
                height: 388,
                buttons: null
            }).dialog('open');
        }

        return sample;
    })(window, $);

    var mailReceive_edit_sample = new mailReceive_edit_fun();
    window['mailReceive_edit_fun'] = null;
    delete window['mailReceive_edit_fun'];
</script>
