<%@ page language="java" contentType="text/html;charset=UTF-8" pageEncoding="UTF-8" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="shiro" uri="http://shiro.apache.org/tags" %>
<%@ taglib prefix="cui" tagdir="/WEB-INF/tags" %>
<c:set var="ctx" value="${pageContext.request.contextPath}"/>
<%
    pageContext.setAttribute("idSuffix", String.valueOf(System.currentTimeMillis()).substring(6));
%>
<cui:layout id="layout${idSuffix}" fit="true">
    <cui:layoutRegion region="center">
        <cui:form id="form${idSuffix}" heightStyle="fill" style="padding: 0px;">
            <div style="width: 100%; margin: 0px auto;">
                <div class="form-wrap2" style="width: 100%;">
                    <table class="form-table" cellpadding="0" cellspacing="0">
                        <tr>
                            <td colspan="1">重打印份数:</td>
                            <td colspan="4"><cui:input id="rePrintNum" name="rePrintNum" width="200"
                                                       validType="naturalnumber"   required="true"></cui:input></td>
                        </tr>
                        <tr>
                            <td colspan="1">申请原因:</td>
                            <td colspan="4"><cui:textarea width="400" id="rePrintReason" name="rePrintReason"
                                                          height="100" required="true"></cui:textarea></td>
                        </tr>
                        <tr>
                            <td colspan="1">附件选取:</td>
                            <td colspan="4" style="padding: 0px;">
                                <div id="fileList2"
                                     style="height: 101px;overflow: auto;background-color: #ffffff;margin: 2px;border: 1px solid #4d4d4d;">
                                        <%--<div style="height: 500px;width: 30px;background-color: red;"></div>--%>
                                </div>
                            </td>
                        </tr>
                    </table>
                </div>
            </div>
        </cui:form>
    </cui:layoutRegion>
    <cui:layoutRegion region="south" style="overflow: hidden;">
        <div class="buttens-foot-tools">
            <a onclick="print_apply_sample.commitThis()">提交</a>
            <a onclick="print_apply_sample.colseD()">返回</a>
        </div>
    </cui:layoutRegion>
</cui:layout>
<script type="text/javascript">
    var print_apply_fun = (function (win, $) {
        var receiveId = '${receiveId}';
        var attachId = '${attachId}'
        var $form = $('#form${idSuffix}');

        function sample() {
        }

        var $thisDialog = $('#layout${idSuffix}').closest('.ctrl-init-dialog');
        var $form = $('#form${idSuffix}');

        $(function () {
            initLoad();
            reloadAttachment();
        });

        //加载
        function initLoad() {

        }

        //关闭
        sample.prototype.colseD = function () {
            closeThisDialog();
        }


        function closeThisDialog() {
            $thisDialog.dialog('close');
        }


        //加载附件
        function reloadAttachment() {
            $.ajax({
                type: 'GET',
                url: '${ctx}/print-num/findPrintMail?attachmentId=' + attachId + "&businessId=" + receiveId,
                dataType: 'json',
                success: function (data) {
                    debugger;
                    var hh = '';
                    $.each(data, function (i, item) {
                        if (item.printNum <= 0) {
                            hh += '<div class="fileItem" id="upload-' + item.id + '">' +
                                '<input type="radio" name="reprintAttach" value=' + item.id + ' > <span>' + item.name + '</span></input>'
                        } else {
                        }
                    });
                    $('#fileList2').html(hh);
                },
                error: function (e) {
                    //hide();
                    error(e);
                }
            });
        }

        //提交
        sample.prototype.commitThis = function () {
            debugger;
            var reprintAttachId = $('input[name="reprintAttach"]:checked').val();
            var reprintAttachName = $('input[name="reprintAttach"]:checked').next("span").text();
            if (!$form.form('valid')) {
                warning('表单填写不正确！');
                return;
            }
            var formData = $form.form('formData');
            $.confirm('确认提交', function (r) {
                if (r) {
                    $.ajax({
                        type: 'GET',
                        url: '${ctx}/print-num/sendRepPrint?reprintAttachId=' + reprintAttachId + "&reprintAttachName=" + reprintAttachName+"&receiveId="+receiveId,
                        dataType: 'json',
                        data: formData,
                        async:false,
                        success: function (data) {
                            if (data.success) {
                                closeThisDialog();
                                $.messageToast("提交申请成功");
                            }else if(data.moreThan1){
                                closeThisDialog();
                                error("请勿重复提交");
                            }
                        }
                    });
                } else {


                }

            });
        }


        return sample;
    })(window, $);

    var print_apply_sample = new print_apply_fun();
    window['print_apply_fun'] = null;
    delete window['print_apply_fun'];
</script>
