<!DOCTYPE html>
<html>
<%@ page contentType="text/html;charset=UTF-8" pageEncoding="UTF-8" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="shiro" uri="http://shiro.apache.org/tags" %>
<c:set var="ctx" value="${pageContext.request.contextPath}"/>
<%
    String basePath = request.getScheme() + "://" + request.getServerName() + ":" + request.getServerPort() + request.getContextPath();
    pageContext.setAttribute("basePath", basePath);
%>
<head>
    <title>查看文件</title>
    <meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
    <script type="text/javascript">
        var _ctx = '${ctx}';
    </script>
    <script src="${ctx}/static/jquery-cui/js/jquery-1.9.1.min.js"></script>
    <script src="${ctx}/static/suwell/suwell_ofdReader.js"></script>
    <style>
        html, body {
            height: 100%;
            width: 100%;
            padding: 0;
            margin: 0;
        }

        .readOnly {
            pointer-events: none;
            filter: alpha(opacity=50); /*IE滤镜，透明度50%*/
            -moz-opacity: 0.5; /*Firefox私有，透明度50%*/
            opacity: 0.5; /*其他，透明度50%*/
            text-decoration: line-through;
            color: darkgrey;
        }

        a {
            color: #000000;
            border: 1px solid #818181;
            background-image: url(${ctx}/static/cm/image/btn-bg.png);
            padding: 4px 15px;
            border-radius: 2px;
            margin: 0px 4px;
            text-decoration: none;
        }
    </style>
</head>
<body>
<div style="text-align: left;width: 100%;height: 100%;">
    <div id="tools" style="height: 40px;padding-top: 5px;">
        <%--
                <button onclick="printFileCopies()" id="canPrint" class="readOnly" >打印</button>
        --%>
        <div class="buttens-foot-tools" style="margin: auto">
            <c:if test="${canDownload==1}">

                <shiro:hasPermission name="/shoujianjia/fjxz">
                <a href="${ctx}/attachment/downloadOriginal/${attachmentId}" target="_blank">下载</a>
                </shiro:hasPermission>
            </c:if>
            <c:if test="${canDownload==0}">
                <shiro:hasPermission name="/shoujianjia/fjxz">
                <a href="${ctx}/attachment/downloadOriginal/${attachmentId}" target="_blank" class="readOnly">下载</a>
                </shiro:hasPermission>
            </c:if>
            <shiro:hasPermission name="/shoujianjia/fjdy">
                <a href="javascript:;" onclick="printFileCopies()" id="canPrint" class="readOnly">打印</a>
                <span id="prtTime"></span>
            </shiro:hasPermission>


        </div>

        <%--
                <button onclick="printFile()">保存</button>
        --%>

    </div>
    <div id="ofdReader" style="">

    </div>
</div>
<script type="text/javascript">
    var exampleOfdUrl = '${basePath}/attachment/viewOfd/${attachmentId}';
    //var exampleOfdUrl ='D:\\upload\\201909\\c4889422-254a-4f40-9666-3c7486316d6a.ofd';
    var ocx = null;
    var attachmentId = '${attachmentId}';
    var businessId = '${businessId}';

    var printTimes = '';

    $(function () {
        init();
        if (ocx) {
            ocx.setCompsiteVisible('f_open', false);//隐藏【打开】菜单
            ocx.setCompsiteVisible('f_save', false);//隐藏【保存】菜单
            ocx.setCompsiteVisible('f_print', false);//隐藏【打印】菜单
            ocx.setCompsiteVisible('f_saveas', false);//显示【另保存】菜单
            ocx.setCompsiteVisible('t_sealsign', false);//隐藏【签章工具栏】
            ocx.setPrintResolution(1080);
            ocx.setConfigInfo('print_fast_checked', false);//“快速打印”不勾选
            openFile(exampleOfdUrl, true);

            // ocx.setPrintCompsiteEnable('copies', false);
            // registListener('f_print', 'beforePrint', false);
            registListener('f_print', 'afterPrint', true);
        }
    });

    /**
     * 初始化插件
     */
    function init() {
        var width = $('body').width();
        var height = $('body').height() - $('#tools').height();
        console.log('width:' + width + ',height:' + height);
        ocx = suwell.ofdReaderInit('ofdReader', width, height);
        initPrintTimes();
    }

    function initPrintTimes() {
        $.ajax({
            type: 'GET',
            url: '${ctx}/print-num/initPrintTimes?attachmentId=' + attachmentId + '&businessId=' + businessId,
            dataType: 'json',
            success: function (data) {
                if (data > 0) {
                    printTimes = data;
                    ocx.setPrintCopies(data);//设置最大打印份数
                    $("#canPrint").removeClass("readOnly")
                    var hh = '<span style="color: green">附件可打印次数:</span><span>' + data + '</span>'
                    $("#prtTime").empty()
                    $("#prtTime").append(hh);
                } else {
                    $("#canPrint").addClass("readOnly")
                    var hh = '<span style="color: red">附件不可被打印</span>'
                    $("#prtTime").empty()

                    $("#prtTime").append(hh);
                }
            }
        })
    }

    function openExample() {
        openFile(exampleOfdUrl, true);
    }

    /**
     * 打开文件
     * @param path string型，欲打开的本地文件路径、http链接或ftp文件路径。
     * @param readOnly boolean，是否只读模式打开。
     * @returns boolean 成功返回true，否则返回false。
     */
    function openFile(path, readOnly) {
        var b = ocx.openFile(path, readOnly);
        return b;
    }

    function registListener(commandId, functionName, after) {
        ocx.registListener(commandId, functionName, after);
    }

    function beforePrint(param) {
        console.log('打印前', param);
    }


    function afterPrint(times) {
        var dom = parseXML(times);
        var timesPrint = dom.querySelector('copies').innerHTML;
        $.ajax({
            type: 'GET',
            url: '${ctx}/print-num/updatePrintNum?attachmentId=' + attachmentId + '&businessId=' + businessId+'&printTime='+timesPrint,
            dataType: 'json',
            success: function (data) {
                if (data) {
                    initPrintTimes();
                }
            }
        })
    }

    function printFile() {

        debugger;

    }

    function printFileCopies() {
        ocx.performClick('f_print');
    }


    // 传入xml 字符串，返回DOM 树
    function parseXML(ret) {
        var xmlDoc = null;
        try //Internet Explorer
        {
            xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
            xmlDoc.async = "false";
            xmlDoc.loadXML(ret);
        } catch (e) {
            try //Firefox, Mozilla, Opera, etc.
            {
                parser = new DOMParser();
                xmlDoc = parser.parseFromString(ret, "text/xml");
            } catch (e) {
                alert(e.message)
            }
        }
        return xmlDoc;
    }

</script>
</body>
</html>