<%@ page language="java" contentType="text/html;charset=UTF-8" pageEncoding="UTF-8" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="shiro" uri="http://shiro.apache.org/tags" %>
<%@ taglib prefix="cui" tagdir="/WEB-INF/tags" %>
<c:set var="ctx" value="${pageContext.request.contextPath}"/>
<%
	pageContext.setAttribute("idSuffix", String.valueOf(System.currentTimeMillis()).substring(6));
%>
<div style="height: 100%;">
	<div class="search-wrap">
		<cui:form id="form${idSuffix}" heightStyle="fill" style="padding: 0px;margin: 0px;">
			<table cellpadding="0" cellspacing="0" width="100%">
				<tr>
					<th width="100">接收单位</th>
					<td>
						<cui:input type="text" name="deptName" componentCls="form-control"/>
					</td>
					<th width="100">接收人</th>
					<td>
						<cui:input type="text" name="receiveUserName" componentCls="form-control"/>
					</td>
				</tr>
				<tr>
					<th>签收时间</th>
					<td>
						<cui:datepicker name="dateBegin" dateFormat="yyyy-MM-dd" componentCls="form-control"/>
					</td>
					<th>到</th>
					<td>
						<cui:datepicker name="dateEnd" dateFormat="yyyy-MM-dd" componentCls="form-control"/>
					</td>
				</tr>
				<tr>
					<th>状态</th>
					<td>
						<cui:combobox name="status" readonlyInput="false" emptyText="-请选择-"
													componentCls="form-control" data="mailReceive_viewList_sample.statusData"/>
					</td>
					<td colspan="2">
						已签收<span id="yqs${idSuffix}">0</span>封
						&nbsp;&nbsp;&nbsp;
						未签收<span id="wqs${idSuffix}">0</span>封
					</td>
				</tr>
			</table>
		</cui:form>
	</div>
	<div class="table-head" style="padding-top:0px;height: 33px;">
		<div class="table-title">收文列表</div>
		<div class="table-head-right">
			<a onclick="mailReceive_viewList_sample.query()">查询</a>
			<a onclick="mailReceive_viewList_sample.force()">强制签收</a>
			<%--<a>催办</a>--%>
		</div>
	</div>
	<cui:grid id="grid${idSuffix}" url="${ctx}/mail-receive/queryViewList/${sendId}" postData="mailReceive_viewList_sample.postData"
						asyncType="get" sortorder="desc" loadonce="false" rownumbers="true" fitStyle="fill" multiselect="true"
						style="margin-left: 5px;margin-right: 5px;">
		<cui:gridCols>
			<cui:gridCol name="id" hidden="true">id</cui:gridCol>
			<cui:gridCol name="status" hidden="true">status</cui:gridCol>
			<cui:gridCol name="deptName" width="60">接收单位</cui:gridCol>
			<cui:gridCol name="receiveUserName" width="20">签收人</cui:gridCol>
			<cui:gridCol name="receiveDate" width="50">签收时间</cui:gridCol>
			<cui:gridCol name="" formatter="mailReceive_viewList_sample.statusFmt" width="20">状态</cui:gridCol>
			<cui:gridCol name="replyText" width="30">回执</cui:gridCol>
		</cui:gridCols>
		<cui:gridPager gridId="grid${idSuffix}"/>
	</cui:grid>
</div>
<cui:dialog id="dialogA${idSuffix}" modal="true" autoOpen="false" reLoadOnOpen="true"
						focusInput="false" resizable="true" autoDestroy="true" maximized="false"></cui:dialog>
<script type="text/javascript">
	var mailReceive_viewList_fun = (function (win, $) {
		var sendId = '${sendId}';

		var originalPostData = {
			//descs: 'SEND_TIME'
		};

		function sample() {
			this.postData = originalPostData;

			this.statusData = [
				{text: '未签收', value: '1'},
				{text: '已签收', value: '2'},
				{text: '强制签收', value: '3'}
			];
		}

		count();

		var $grid = $('#grid${idSuffix}');

		//刷新列表
		sample.prototype.reloadGrid = function () {
			$grid.grid('reload');
		}

		sample.prototype.statusFmt = function (cellValue, options, rowObject) {
			var result = '';
			var status = rowObject.status;
			if (status == '1') {
				result = '未签收';
			} else if (status == '2') {
				result = '已签收';
			} else if (status == '3') {
				result = '强制签收';
			} else {
				result = status;
			}
			return result;
		}

		//查看
		sample.prototype.query = function () {
			var formData = $('#form${idSuffix}').form('formData');
			this.postData = $.extend(originalPostData, formData);
			$grid.grid('reload', {page: 1});
		}

		//强制签收
		sample.prototype.force = function () {
			var selrows = $grid.grid('option', 'selarrrow');
			if (selrows.length < 1) {
				warning('请选择要强制签收的记录！');
				return;
			}
			var ids = [];
			var hasReceived = false;
			for (var i = 0; i < selrows.length; i++) {
				var rowData = $grid.grid('getRowData', selrows[i]);
				if (rowData.status != '1') {
					hasReceived = true;
					break;
				}
				ids.push(rowData.id);
			}
			if (hasReceived) {
				warning('选择的记录有已签收的！');
				return;
			}
			$.confirm('确定要强制签收吗？', function (r) {
				if (r) {
					//loading('强制签收中...');
					$.ajax({
						type: 'POST',
						url: '${ctx}/mail-receive/forceReceive',
						data: {
							ids: ids.join(',')
						},
						dataType: 'json',
						success: function (data) {
							//hide();
							if (data == true) {
								message('强制签收成功！');
							}
							$grid.grid('reload');
							count();
						},
						error: function (e) {
							//hide();
							error(e);
						}
					});
				}
			});
		}

		/**
		 * 签收数量
		 */
		function count() {
			$.ajax({
				type: 'GET',
				url: '${ctx}/mail-receive/countGroupByStatus/' + sendId,
				dataType: 'json',
				success: function (data) {
					//console.log('签收数量', data);
					if (data != null && data.length > 0) {
						var wqs = 0;//未签收数量
						var yqs = 0;//已签收数量
						$.each(data, function (i, item) {
							if (item.STATUS == '1') {
								wqs += item.C;
							} else {
								yqs += item.C;
							}
						});
						$('#wqs${idSuffix}').html(wqs);
						$('#yqs${idSuffix}').html(yqs);
					}
				},
				error: function (e) {
					//error(e);
				}
			});
		}

		return sample;
	})(window, $);

	var mailReceive_viewList_sample = new mailReceive_viewList_fun();
	window['mailReceive_viewList_fun'] = null;
	delete window['mailReceive_viewList_fun'];
</script>
