<%--
  since: 2019/7/8 17:59
  author: shen.shaohua
  description: 添加发文页面
  url: ${ctx}/mail-send/add
--%>
<%@ page language="java" contentType="text/html;charset=UTF-8" pageEncoding="UTF-8" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="shiro" uri="http://shiro.apache.org/tags" %>
<%@ taglib prefix="cui" tagdir="/WEB-INF/tags" %>
<%@ page import="cn.hutool.core.date.DateUtil" %>
<c:set var="ctx" value="${pageContext.request.contextPath}"/>
<%@ page import="com.cesgroup.bdc.util.PrimaryKey" %>
<%
    pageContext.setAttribute("idSuffix", String.valueOf(System.currentTimeMillis()).substring(6));
    pageContext.setAttribute("today", DateUtil.today());
    pageContext.setAttribute("attachmentModule", "mail");
    String relevanceId = PrimaryKey.tempId();
    pageContext.setAttribute("relevanceId", relevanceId);
%>
<style type="text/css">
    #fileUpload${idSuffix}_queueID {
        display: none;
    }

    #fileBtn${idSuffix} {
        background: none;
        background-color: transparent;
        border: none;
        color: red;
    }

    #fileBtn${idSuffix} .coral-button-text {
        padding: 0px;
    }
</style>
<cui:layout id="layout${idSuffix}" fit="true">
    <cui:layoutRegion region="center">
        <cui:form id="form${idSuffix}" heightStyle="fill" style="padding: 0px;">
            <input type="hidden" name="id" id="id${idSuffix}"/>
            <div style="width: 100%;margin: 0px auto;">
                <div class="form-wrap2" style=" padding-top: 20px">
                    <table class="form-table" width="70px" cellpadding="0" cellspacing="0">
                        <tr>
                            <td width="25%" class="td-width"></td>
                            <td class="td-width"></td>
                        </tr>
                        <tr>
                            <th class="table-head" colspan="2">属性相关</th>
                        </tr>
                        <tr>
                            <th><span class="validate-required">*</span>文电类型</th>
                            <td>
                                <cui:combobox name="mailType" readonlyInput="false" emptyText="-请选择-"
                                              width="200" data="mailSend_add_sample.mailTypeData" required="true"/>
                            </td>
                        </tr>
                        <tr>
                            <th>密级</th>
                            <td>
                                <cui:combobox name="safeLevel" id="safeLevel${idSuffix}" readonlyInput="false"
                                              width="200" data="mailSend_add_sample.safeLevelData"/>
                            </td>
                        </tr>
                        <tr>
                            <th>紧急度</th>
                            <td>
                                <cui:combobox name="emergency" readonlyInput="false"
                                              width="200" data="mailSend_add_sample.emergencyData"/>
                            </td>
                        </tr>
                        <tr>
                            <th>会议时间</th>
                            <td>
                                <cui:datepicker name="partyTime" dateFormat="yyyy-MM-dd HH:mm:ss" width="200"
                                                minDate="${today}"/>
                            </td>
                        </tr>
                        <tr>
                            <th><span class="validate-required">*</span>有效时间</th>
                            <td>
                                <cui:datepicker name="effDate" dateFormat="yyyy-MM-dd" width="200" required="true"
                                                readonlyInput="true" minDate="${today}"/>
                            </td>
                        </tr>
                        <tr>
                            <th><span class="validate-required">*</span>打印份数</th>
                            <td>
                                <cui:input type="text" name="printNum" validType="naturalnumber" width="200"
                                           required="true" value="10"/>
                            </td>
                        </tr>
                        <tr>
                            <th><span class="validate-required">*</span>文电页数</th>
                            <td>
                                <cui:input type="text" name="mailPage" validType="naturalnumber" required="true" width="200"/>
                            </td>
                        </tr>
                        <tr>
                            <th>是否提供下载</th>
                            <td>
                                <cui:radiolist name="canDownload" repeatLayout="flow"
                                               data="mailSend_add_sample.canDownloadData"/>
                            </td>
                        </tr>
                        <tr>
                            <th>是否用章</th>
                            <td>
                                <cui:radiolist id="canStamp${idSuffix}" name="canStamp" repeatLayout="flow"
                                               data="mailSend_add_sample.canStamp" onChange="mailSend_add_sample.isStamp"/>
                            </td>
                        </tr>
                    </table>
                </div>
                <div class="form-wrap2" style="padding-left: 1px; padding-top: 20px">
                    <table class="form-table" cellpadding="0" cellspacing="0">
                        <tr>
                            <td width="20%" class="td-width"></td>
                            <td class="td-width"></td>
                        </tr>
                        <tr>
                            <th class="table-head" colspan="2">内容相关</th>
                        </tr>
                        <tr>
                            <th><span class="validate-required">*</span>标题</th>
                            <td>
                                <cui:input name="mailTitle" componentCls="form-control" required="true"/>
                            </td>
                        </tr>
                        <tr>
                            <th>正文</th>
                            <td>
                                <cui:textarea name="mailText" componentCls="form-control" height="95"></cui:textarea>
                            </td>
                        </tr>
                        <tr>
                            <th>
                                <a style="color: #ff0000" onclick="mailSend_add_sample.jsdwPicker()">
                                    <span class="validate-required">*</span>接收单位
                                </a>
                            </th>
                            <td>
                                <input type="hidden" name="receiveDept" id="receiveDept${idSuffix}"/>
                                <cui:textarea id="deptNames${idSuffix}" componentCls="form-control" readonly="true"
                                              required="true" cls="cm-readonly" height="80"/>
                            </td>
                        </tr>
                        <tr>
                            <th>
                                <a onclick="mailSend_add_sample.fileUploadButton1()" style="text-decoration:none;float: right;color: red;">添加附件</a>
                                <cui:fileuploader id="fileUpload${idSuffix}" uploadBtn="#fileBtn${idSuffix}"
                                                  url="${ctx}/attachment/upload/${attachmentModule}/${relevanceId}"
                                                  maxFileSize="100000kb" acceptFileTypes="*.*"
                                                  autoUpload="true" required="true" multiple="true"
                                                  uploadBtnOptions="{label: '添加附件'}"
                                                  onSuccess="mailSend_add_sample.uploadOnSuccess"
                                                  onStart="loading('正在上传，请稍候...')" onComplete="hide()" style="display:none;">
                                    <span id="fileBtn${idSuffix}"></span>
                                </cui:fileuploader>
                            </th>
                            <td style="padding: 0px;">
                                <div id="fileList${idSuffix}" style="height: 90px;overflow: auto;background-color: #ffffff;margin: 2px;border: 1px solid #4d4d4d;">
                                        <%--<div style="height: 500px;width: 30px;background-color: red;"></div>--%>
                                    <span style="margin-left: 5px;">
                                        <cui:radiolist id="securityLevelFile1${idSuffix}" repeatLayout="flow" readonly="false" column="4" name="securityLevelFile1" data="mailSend_add_sample.securityLevelFileData"></cui:radiolist>
                                    </span>
                                </div>

                            </td>
                        </tr>
                    </table>
                </div>
            </div>
        </cui:form>
    </cui:layoutRegion>
    <cui:layoutRegion region="south" style="overflow: hidden;">
        <div class="buttens-foot-tools">
            <a id="edityz" onclick="mailSend_add_sample.save()" style="display: none">用章</a>
            <a id="editfs" onclick="mailSend_add_sample.send()">发送</a>
            <a onclick="mailSend_add_sample.colseD()">关闭</a>
        </div>
    </cui:layoutRegion>
</cui:layout>
<cui:dialog id="dialogB${idSuffix}" modal="true" autoOpen="false" resizable="true"
            autoDestroy="true" reLoadOnOpen="true" maximized="false"></cui:dialog>
<script type="text/javascript">
    var mailSend_add_fun = (function (win, $) {
        function sample() {
            //文电类型
            this.mailTypeData = [
                {text: '文件', value: '文件'},
                {text: '简报', value: '简报'},
                {text: '会议通知', value: '会议通知'},
                {text: '一般通知', value: '一般通知'},
                {text: '信息', value: '信息'},
            ];

            //密级
            this.safeLevelData = [
                {text: '无', value: '无', selected: true},
                {text: '秘密', value: '秘密'},
                {text: '机密', value: '机密'}
            ];
            //文件密级
            this.securityLevelFileData = [
                /*{text: '普通', value: '普通',checked:true},*/
                {text: '无', value: '无'},
                {text: '秘密', value: '秘密'},
                {text: '机密', value: '机密'},
                /*{text: '绝密', value: '绝密'}*/
            ];

            //紧急度
            this.emergencyData = [
                {text: '无', value: '无', selected: true},
                {text: '平急', value: '平急'},
                {text: '加急', value: '加急'},
                {text: '特急', value: '特急'},
                {text: '特提', value: '特提'}
            ];

            this.canDownloadData = [
                {text: '是', value: '1', checked: true},
                {text: '否', value: '0'}
            ];

            this.canStamp = [
                {text: '是', value: '1'},
                {text: '否', value: '0', checked: true}
            ];
        }

        var $thisDialog = $('#layout${idSuffix}').closest('.ctrl-init-dialog');
        var $form = $('#form${idSuffix}');

        var selectDepts = [];//已选单位

        //关闭
        sample.prototype.colseD = function () {
            closeThisDialog();
        }

        //是否用章
        sample.prototype.isStamp = function () {
            console.log($("#canStamp${idSuffix}").radiolist("getValue"))
            $("canStamp${idSuffix}").radiolist("getValue")
            if ($("#canStamp${idSuffix}").radiolist("getValue")==1){
                $("#edityz").removeAttr("style","display:none")
                $("#editfs").attr("style","display:none")
            }else {
                $("#edityz").attr("style","display:none")
                $("#editfs").removeAttr("style")
            }
        }

        //发送
        sample.prototype.send = function () {
            if (!$form.form('valid')) {
                warning('表单填写不正确！');
                return;
            }
            $.confirm('发送后将无法用章<br>确定要发送吗？', function (r) {
                if (r) {
                    var formData = $form.form('formData');
                    formData.tempRelevanceId = '${relevanceId}';
                    console.log(formData);
                    //return;
                    loading('发送中...');
                    $.ajax({
                        type: 'POST',
                        url: '${ctx}/mail-send/send',
                        data: formData,
                        dataType: 'json',
                        success: function (data) {
                            hide();
                            if (data.status == 'success') {
                                message('发送成功！');
                            }
                            mailSend_list_sample.reloadGrid();
                            closeThisDialog();
                        },
                        error: function (e) {
                            hide();
                            error(e);
                        }
                    });
                }
            });

        }

        //暂存
        sample.prototype.save = function () {
            if (!$form.form('valid')) {
                warning('表单填写不正确！');
                return;
            }
            console.log($('#fileList${idSuffix}').html())
            console.log($('#fileList${idSuffix}').html().indexOf("</a>"))
            if ($('#fileList${idSuffix}').html().indexOf("</a>")==-1){
                warning('没有用章的附件！');
                return;
            }
            var formData = $form.form('formData');
            formData.tempRelevanceId = '${relevanceId}';
            console.log(formData);
            //return;
            loading('暂存中...');
            $.ajax({
                type: 'POST',
                url: '${ctx}/mail-send/saves',
                data: formData,
                dataType: 'json',
                success: function (data) {
                    hide();
                    mailSend_list_sample.reloadGrid();
                    closeThisDialog();
                    mailSend_list_sample.stamp1(data.id);
                },
                error: function (e) {
                    hide();
                    error(e);
                }
            });
        }

        function closeThisDialog() {
            $thisDialog.dialog('close');
        }

        sample.prototype.printAttachment = function (attachId, mailReceiveId) {
            var url = '${ctx}/print-num/updatePrintNum3?attachId=' + attachId;
            window.open(url);
        }

        //选择部门
        sample.prototype.jsdwPicker = function () {
            var url = '${ctx}/auth/selectDept?initfun=mailSend_add_sample.initfun&callback=mailSend_add_sample.deptCallback';
            $('#dialogB${idSuffix}').dialog('option', {
                url: url,
                title: '添加单位',
                asyncType: 'get',
                width: 735,
                height: 565,
                buttons: null
            }).dialog('open');
        }

        //获取已选单位
        sample.prototype.initfun = function () {
            return selectDepts;
        }

        //选择部门回调方法
        sample.prototype.deptCallback = function (selectDeptArray) {
            selectDepts = selectDeptArray;
            var str = JSON.stringify(selectDeptArray);
            $('#receiveDept${idSuffix}').val(str);
            var dd = '';
            $.each(selectDeptArray, function (i, item) {
                if (i > 0) dd += ',';
                dd += item.deptName;
            });
            $('#deptNames${idSuffix}').textbox('setValue', dd);
        }
        sample.prototype.fileUploadButton1 = function(){
            console.error($("#securityLevelFile1${idSuffix}").radiolist( "getValue" ));
            if(isEmpty($("#securityLevelFile1${idSuffix}").radiolist("getValue" ))){
                error("请选择正文附件密级！");
                return;
            }
            //$("#fileUpload1${idSuffix}").fileuploader("upload");
            console.error("启动上传！！！！！")
            //$("#fileBtn1${idSuffix}").click();
            //$("#fileBtn1${idSuffix}").trigger("click")
            //("#fileBtn1${idSuffix}").fileuploader("upload");
            //console.log("haha:==>",securityLevelFile);
            //sendInfo_add.formData1 = {securityLevelFile: "B"};
            $('#fileUpload${idSuffix} input').click();

        }
        //上传附件成功
        sample.prototype.uploadOnSuccess = function (event, ui) {
            /*console.log('event', event);
            console.log('ui', ui);*/
            console.error(ui,ui.file)
            //添加附件上传成功以后该条信息的密级。
            var securityLevelFile1 = $("#securityLevelFile1${idSuffix}").radiolist("getValue" );
            if(!isEmpty(securityLevelFile1)&&!isEmpty(ui.file)){
                if(!isEmpty(ui.file.id)){
                    var ids =[];
                    ids.push(ui.file.id)
                    updateSecurityLevelFile(ids,securityLevelFile1);
                    ui.file.securityLevelFile = securityLevelFile1;
                }
            }
            var file = ui.file;
            var hh = '';
            var securityLevelFileText = "";
            if(file.securityLevelFile!=null){
                securityLevelFileText = '('+file.securityLevelFile+')';
            }

            var securityLevel = "(无)";
            if(!isEmpty($("#safeLevel${idSuffix}").combobox("getValue"))){
                securityLevel = '('+ $("#safeLevel${idSuffix}").combobox("getValue")+')';
            }

            if (file.ext == 'zip' || file.ext == 'rar' || file.ext == 'ZIP' || file.ext == 'RAR' || file.ext == '7z') {
                if(file.securityLevelFile!=null){
                    hh += '<div class="fileItem" id="upload-' + file.id + '">' +
                        '<a  href="${ctx}/attachment/downloadOriginal/' + file.id + '"    target="_blank">' + file.name + securityLevelFileText + '</a></div>'
                }else{
                    hh += '<div class="fileItem" id="upload-' + file.id + '">' +
                        '<a  href="${ctx}/attachment/downloadOriginal/' + file.id + '"    target="_blank">' + file.name + securityLevel + '</a></div>'
                }

            } else {
                if(file.securityLevelFile!=null){
                    hh += '<div class="fileItem" id="upload-' + file.id + '">' +
                        '<a onclick="mailSend_add_sample.printAttachment(\'' + file.id + '\',\'' + '${relevanceId}' + '\')" target="_blank">' + file.name + securityLevelFileText + '</a>' +
                        '<i class="icon-cross2" title="删除" onclick="mailSend_add_sample.delAttachment(\'' + file.id + '\')"></i>' +
                        '</div>'
                }else{
                    hh += '<div class="fileItem" id="upload-' + file.id + '">' +
                        '<a onclick="mailSend_add_sample.printAttachment(\'' + file.id + '\',\'' + '${relevanceId}' + '\')" target="_blank">' + file.name + securityLevel + '</a>' +
                        '<i class="icon-cross2" title="删除" onclick="mailSend_add_sample.delAttachment(\'' + file.id + '\')"></i>' +
                        '</div>'
                }

            }

            $('#fileList${idSuffix}').append(hh);
        }
        //判断字符是否为空的方法
        function isEmpty(obj) {
            if (typeof obj == "undefined" || obj == null || obj == "") {
                return true;
            } else {
                return false;
            }
        }
        //修改附件密级
        function updateSecurityLevelFile(ids,securityLevelFile) {
            if (ids == null || ids.length == 0) {
                return;
            }
            console.log("ids==>",ids)
            var idsStr = ids.join(',');
            $.ajax({
                type: 'POST',
                url: '${ctx}/attachment/updateSecurityLevelFile',
                data: {"ids": idsStr,securityLevelFile:securityLevelFile},
                dataType: 'json',
                success: function (data) {
                    if (data.code == "0") {
                        console.log("附件密级修改成功！")
                    } else {
                        console.log("附件密级修改失败！")
                    }
                }
            });
        }

        sample.prototype.delAttachment = function (id) {
            loading('删除中...');
            $.ajax({
                type: 'DELETE',
                url: '${ctx}/attachment/del/' + id,
                dataType: 'json',
                success: function (data) {
                    hide();
                    //console.log(data, typeof data);
                    if (data == true) {
                        $('#upload-' + id).remove();
                    }
                },
                error: function (e) {
                    hide();
                    error(e);
                }
            });
        }

        return sample;
    })(window, $);

    var mailSend_add_sample = new mailSend_add_fun();
    window['mailSend_add_fun'] = null;
    delete window['mailSend_add_fun'];
</script>
