<%@ page language="java" contentType="text/html;charset=UTF-8" pageEncoding="UTF-8" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="shiro" uri="http://shiro.apache.org/tags" %>
<%@ taglib prefix="cui" tagdir="/WEB-INF/tags" %>
<c:set var="ctx" value="${pageContext.request.contextPath}"/>
<%
  pageContext.setAttribute("idSuffix", String.valueOf(System.currentTimeMillis()).substring(6));
%>
<div style="height: 100%;">
  <div class="nav2"><img src="${ctx}/static/cm/image/fjj-nav.png"/>发件夹</div>
  <div class="table-head">
    <div class="table-title">发文列表</div>
  </div>
  <cui:form id="searchForm${idSuffix}" style="margin: 0px;padding: 0px;">
    <div style="text-align: center;padding: 5px 7px 10px 6px;">
      <span style="padding-left: 20px">文电标题:</span>
      <cui:input type="text" name="mailTitle" id="mailTitle${idSuffix}" width="120" required="false" value="${title}"/>
      <span style="padding-left: 20px;">发送时间:</span>
      <cui:datepicker width="120" name="sendTimeStart" dateFormat="yyyy-MM-dd"/>
      至
      <cui:datepicker width="120" name="sendTimeEnd" dateFormat="yyyy-MM-dd"/>
      <span style="padding-left: 20px;">状态:</span>
      <cui:combobox name="status" id="status${idSuffix}" readonlyInput="false"
                    width="120" data="mailSend_list_sample.statusData" emptyText="请选择"/>
      <span class="btn-bar">
          <a id="search${idSuffix}" onclick="mailSend_list_sample.search()">查询</a>
        </span>
      <span class="table-head-right">
					<a onclick="mailSend_list_sample.add()">添加</a>
					<a onclick="mailSend_list_sample.del()">删除</a>
				</span>
    </div>
  </cui:form>
  <cui:grid id="grid${idSuffix}" url="${ctx}/mail-send/queryList?sendId=${sendId}" asyncType="get"
            postData="mailSend_list_sample.postData"
            sortorder="desc" loadonce="false" rownumbers="true" fitStyle="fill" multiselect="true"
            style="margin-left: 5px;margin-right: 5px;" cellattr="padding-left: 20px;">
    <cui:gridCols >
      <cui:gridCol name="id" hidden="true">id</cui:gridCol>
      <%--<cui:gridCol name="mailNo" width="35">发文号</cui:gridCol>--%>
      <cui:gridCol align="center"  name="mailTitle" formatter="mailSend_list_sample.titleFmt" width="95">文电标题</cui:gridCol>
      <cui:gridCol align="center" name="mailType" width="15">类型</cui:gridCol>
      <cui:gridCol align="center" name="emergency" width="17">紧急度</cui:gridCol>
      <cui:gridCol align="center" name="safeLevel" width="15">密级</cui:gridCol>
      <cui:gridCol align="center" name="mailPage" width="15">页数</cui:gridCol>
      <cui:gridCol align="center" name="sendTime" width="35">发送时间</cui:gridCol>
      <%--<cui:gridCol  name="yzStatus" formatter="mailSend_list_sample.yzStatusFmt" width="35">用章状态</cui:gridCol>
      <cui:gridCol name="status" formatter="mailSend_list_sample.statusFmt" width="35">状态</cui:gridCol>--%>
      <cui:gridCol align="center" name="cz" width="35" formatter="mailSend_list_sample.czFmt">操作</cui:gridCol>
    </cui:gridCols>
    <cui:gridPager gridId="grid${idSuffix}"/>
  </cui:grid>
</div>
<cui:dialog id="dialogA${idSuffix}" modal="true" autoOpen="false" reLoadOnOpen="true"
            focusInput="false" resizable="true" autoDestroy="true" maximized="false"></cui:dialog>
<script type="text/javascript">
  var mailSend_list_fun = (function (win, $) {
    function sample() {
      this.postData = {
        orderBy: 'STATUS@asc,SEND_TIME@desc'
        //,status: '0'
      }

      this.statusData = [
        {text: '未完成', value: '0'},
        {text: '完成', value: '1'}
      ];
    }

    var $grid = $('#grid${idSuffix}');
    $.parseDone(function () {
      if ('${title}'!=null){
        $('#search${idSuffix}').click()
      }
    })
    //查询
    sample.prototype.search = function () {
      console.log("开始查询！")
      var $form = $('#searchForm${idSuffix}');
      var formData = $form.form('formData');
      if (formData.sendTimeStart) formData.sendTimeStart = formData.sendTimeStart + '00:00:00';
      if (formData.sendTimeEnd) formData.sendTimeEnd = formData.sendTimeEnd + '23:59:59';
      this.postData = $.extend(this.postData, formData);
      $grid.grid('reload', {page: 1});
    }

    //添加
    sample.prototype.add = function () {
      var url = '${ctx}/mail-send/add';
      $('#dialogA${idSuffix}').dialog('option', {
        url: url,
        title: '添加发文',
        asyncType: 'get',
        width: 1000,
        height: 550,
        buttons: null
      }).dialog('open');
    }

    //删除
    sample.prototype.del = function () {
      var selrows = $grid.grid('option', 'selarrrow');
      if (selrows.length < 1) {
        warning('请选择要删除的记录！');
        return;
      }
      var ids = [];
      for (var i = 0; i < selrows.length; i++) {
        var rowData = $grid.grid('getRowData', selrows[i]);
        ids.push(rowData.id);
      }
      $.confirm('将同时删除发件夹和用章申请相关信息<br>确定要删除吗？', function (r) {
        if (r) {
          loading('删除中...');
          $.ajax({
            type: 'DELETE',
            url: '${ctx}/mail-send/del/',
            data: {
              ids: ids.join(',')
            },
            dataType: 'json',
            success: function (data) {
              hide();
              if (data == true) {
                message('删除成功！');
              }
              $grid.grid('reload');
            },
            error: function (e) {
              hide();
              error(e);
            }
          });
        }
      });
    }

    //刷新列表
    sample.prototype.reloadGrid = function () {
      $grid.grid('reload');
    }

    sample.prototype.titleFmt = function (cellValue, options, rowObject) {
      var result = '<a onclick="mailSend_list_sample.edit(\'' + rowObject.id + '\')">' + cellValue + '</a>';
      return result;
    }

    sample.prototype.statusFmt = function (cellValue, options, rowObject) {
      var result = '';
      var status = rowObject.status;
      if (status == '0') {
        result = '未完成';
      } else if (status == '1') {
        result = '完成';
      }else if (status == '-1') {
        result = '未发送';
      } else {
        result = status;
      }
      return result;
    }
    sample.prototype.czFmt = function (cellValue, options, rowObject) {
      var result = '';
      var status = rowObject.status;
      var bussinessId=rowObject.id;
      var mailTitle=rowObject.mailTitle;
      $.ajax({
        type: 'POST',
        url: "${ctx}/stamp/selectBySendId1/"+bussinessId,
        dataType: 'json',
        async:false,
        success: function (data) {
          hide();
          if (data.length>0){
            if (data[0].status!="已完成"){
              result='<img src="${ctx}/static/cm/image/yz-image.png" style="width:16px;height: 16px"/>'+data[0].status;
            }else {
              if (status == '0') {
                result = '<img src="${ctx}/static/cm/image/fs-image.png" style="width:16px;height: 16px"/>未完成 <img src="${ctx}/static/cm/image/yz-image.png" style="width:16px;height: 16px"/>已盖章';
              } else if (status == '1') {
                result = '<img src="${ctx}/static/cm/image/fs-image.png"/>完成 <img src="${ctx}/static/cm/image/yz-image.png" style="width:16px;height: 16px"/>已盖章';
              }else if (status == '-1'){
                result='<img src="${ctx}/static/cm/image/fs-image.png"/><a style="text-decoration: underline" onclick="mailSend_list_sample.send(\''+bussinessId+'\',\''+mailTitle+'\')">发送</a> <img src="${ctx}/static/cm/image/yz-image.png" style="width:16px;height: 16px"/>已盖章';
              }
            }

          }else {
            if (status == '0') {
              result = '<img src="${ctx}/static/cm/image/fs-image.png"/>未完成';
            } else if (status == '1') {
              result = '<img src="${ctx}/static/cm/image/fs-image.png"/>完成';
            }else if (status == '-1'){
              result='<img src="${ctx}/static/cm/image/fs-image.png"/><a style="text-decoration: underline" onclick="mailSend_list_sample.send(\''+bussinessId+'\',\''+mailTitle+'\')">发送</a> ' +
                      '<img src="${ctx}/static/cm/image/yz-image.png" style="width:16px;height: 16px"/><a style="text-decoration: underline" onclick="mailSend_list_sample.stamp(\''+bussinessId+'\')">用章</a>';
            }
          }
        },
        error: function (e) {
          hide();
          error(e);
        }
      });
      return result;
    }
    sample.prototype.yzStatusFmt = function (cellValue, options, rowObject) {
      var result = '';
      var id = rowObject.id;
      $.ajax({
        type:"GET",
        url:"${ctx}/stamp/selectBySendId1/"+id,
        async: false,
        dataType: 'json',
        success: function (data) {
          hide();
          if (data.length>0){
            if (data[0].status!="已完成"){
              result=data[0].status;
            }else {
              result="已盖章";
            }

          }
        },
        error: function (e) {
          hide();
          error(e);
        }
      });

      return result;
    }

    //查看
    sample.prototype.edit = function (id) {
      var url = '${ctx}/mail-send/edit/' + id;
      $('#dialogA${idSuffix}').dialog('option', {
        url: url,
        title: '发文',
        asyncType: 'get',
        width: 1000,
        height: 550,
        buttons: null
      }).dialog('open');
    }

    //用章
    sample.prototype.stamp = function (id) {
      console.log(id)
      var url = '${ctx}/stamp/addStamp/' + id;
      console.log(id)
      $('#dialogA${idSuffix}').dialog('option', {
        url: url,
        title: '用章',
        asyncType: 'get',
        width: 1000,
        height: 550,
        buttons: null
      }).dialog('open');

    }
    sample.prototype.send = function (bussinessId,mailTitle) {
      loading('发送中...');
      $.ajax({
        type: 'POST',
        url: '${ctx}/mail-send/sends1',
        data: {id:bussinessId,mailTitle:mailTitle},
        dataType: 'json',
        success: function (data) {
          hide();
          if (data.status == 'success') {
            message('发送成功！');
          }
          mailSend_list_sample.reloadGrid();
          closeThisDialog();
        },
        error: function (e) {
          hide();
          error(e);
        }
      });
    }
    sample.prototype.stamp1 = function (id) {
      /*console.log("用章！")
      var selrows = $grid.grid('option', 'selarrrow');
      if (selrows.length != 1) {
        warning('请选择一条要用章的记录！');
        return;
      }
      var ids = [];
      for (var i = 0; i < selrows.length; i++) {
        var rowData = $grid.grid('getRowData', selrows[i]);
        if (rowData.status != "未发送") {
          console.log(rowData.status)
          warning('已发送的不能申请用章！');
          return;
        }
        ids.push(rowData.id);
      }
      var id=ids[0];*/
      var url = '${ctx}/stamp/addStamp/' + id;
      console.log(id)
      $('#dialogA${idSuffix}').dialog('option', {
        url: url,
        title: '用章',
        asyncType: 'get',
        width: 1000,
        height: 550,
        buttons: null
      }).dialog('open');
    }
    return sample;
  })(window, $);
  var mailSend_list_sample = new mailSend_list_fun();
  window['mailSend_list_fun'] = null;
  delete window['mailSend_list_fun'];

</script>
