<%--
  since: 2019/7/24 15:32
  author: shen.shaohua
  description: 登录日志列表页面
  url: ${ctx}/login-log/index
--%>
<%@ page contentType="text/html;charset=UTF-8" pageEncoding="UTF-8" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="shiro" uri="http://shiro.apache.org/tags" %>
<%@ taglib prefix="cui" tagdir="/WEB-INF/tags" %>
<c:set var="ctx" value="${pageContext.request.contextPath}"/>
<%
    pageContext.setAttribute("idSuffix", String.valueOf(System.currentTimeMillis()).substring(6));
%>
<div style="height: 100%;">
    <div class="nav2"><img src="${ctx}/static/cm/image/xtgl-nav.png"/>打印查询</div>
    <cui:form id="queryForm${idSuffix}" method="post" style="padding-left: 10px;height: 50px;">
        <div>
            <label>单位名称：</label>
            <cui:input type="text" name="deptName" componentCls="form-control" width="150"
                       pattern="//^([\u4e00-\u9fa5]|[a-zA-Z0-9])+$//" errMsg="请输入合法字符"/>
            <label>文号：</label>
            <cui:input type="text" name="mailNo" componentCls="form-control" width="150"
                       pattern="//^([\u4e00-\u9fa5]|[a-zA-Z0-9])+$//" errMsg="请输入合法字符"/>
            <label>文件名称：</label>
            <cui:input type="text" name="fileName" componentCls="form-control" width="150"
                       pattern="//^([\u4e00-\u9fa5]|[a-zA-Z0-9])+$//" errMsg="请输入合法字符"/>

            &nbsp;<cui:button id="logSearch" componentCls="sbax_button_blue " width="80"
                              icons="icon-search" label="查询"
                              onClick="printRecord_index_sample.search()"/>
            <cui:button id="resetSearch" componentCls="sbax_button_yellow" icons="icon-reset" width="80"
                              label="重置"
                              onClick="printRecord_index_sample.reset()"/>
            <cui:button id="resetSearch" componentCls="sbax_button_green" icons="icon-printer" width="80"
                        label="清单"
                        onClick="printRecord_index_sample.exp()"/>
          <%--  <a onclick="printRecord_index_sample.search()"><img src="${ctx}/static/cm/image/bicon-cx.png"/>查询</a>
            <a onclick="printRecord_index_sample.reset()"><img src="${ctx}/static/cm/image/bicon-cz.png"/>重置</a>
            <a onclick="printRecord_index_sample.exp()"><img src="${ctx}/static/cm/image/bicon-cz.png"/>清单</a>--%>

        </div>
    </cui:form>
    <div class="nav2">打印记录</div>
    <cui:grid id="grid${idSuffix}" url="${ctx}/print-record/indexQuery" asyncType="get"
              postData="printRecord_index_sample.postData"
              sortorder="desc" loadonce="false" rownumbers="true" fitStyle="fill" multiselect="false" altRows="true"
              style="margin-left: 5px;margin-right: 5px;">
        <cui:gridCols>
            <cui:gridCol name="fileName" width="50">文件名</cui:gridCol>
            <cui:gridCol name="mailNo" width="30">文号</cui:gridCol>
            <cui:gridCol name="deptName" width="60">接收单位</cui:gridCol>
            <cui:gridCol name="printNum" width="30">份数</cui:gridCol>
            <cui:gridCol name="alreadyPrintNum" width="30">已打印份数</cui:gridCol>
            <cui:gridCol name="mx" width="40" formatter="printRecord_index_sample.mxFmt">明细</cui:gridCol>
        </cui:gridCols>
        <cui:gridPager gridId="grid${idSuffix}"/>
    </cui:grid>
</div>

<cui:form id="expForm${idSuffix}" action="${ctx}/print-record/indexQuery/exp"
          target="_blank" style="display: none;">
    <input type="hidden" name="fileName"/>
    <input type="hidden" name="mailNo"/>
    <input type="hidden" name="deptName"/>
    <input type="hidden" name="printNum"/>
    <input type="hidden" name="alreadyPrintNum"/>
</cui:form>
<cui:dialog id="dialogG${idSuffix}" modal="true" autoOpen="false" reLoadOnOpen="true"
            focusInput="false" resizable="true" autoDestroy="true" maximized="false"></cui:dialog>
<script type="text/javascript">
    var printRecord_index_fun = (function (win, $) {
        var originalPostData = {
            descs: 's.SEND_TIME'
        };

        function sample() {
            this.postData = originalPostData;


        }

        var $form = $('#queryForm${idSuffix}');
        var $grid = $('#grid${idSuffix}');
        var $expForm = $('#expForm${idSuffix}');


        sample.prototype.mxFmt = function (cellValue, options, rowObject) {
            var result = '<a onclick="printRecord_index_sample.mx(\'' + rowObject.deptId + '\',\'' + rowObject.attachmentId + '\')">明细</a>';
            return result;
        }

        //明细
        sample.prototype.mx = function (deptId, attachmentId) {
            var url = '${ctx}/print-record/detailList?deptId=' + deptId + "&attachmentId=" + attachmentId;
            $('#dialogG${idSuffix}').dialog('option', {
                url: url,
                title: '收件',
                asyncType: 'get',
                width: 700,
                height: 400,
                buttons: null
            }).dialog('open');
        }

        //搜索
        sample.prototype.search = function () {
            debugger;
            var formData = $form.form('formData');
            this.postData = $.extend(originalPostData, formData);
            $grid.grid('reload', '${ctx}/print-record/queryByKeyWords');
        }

        //重置
        sample.prototype.reset = function () {
            $form.form('clear');
        }

        sample.prototype.exp = function () {
            $expForm.submit();
        }

        return sample;
    })(window, $);

    var printRecord_index_sample = new printRecord_index_fun();
    window['printRecord_index_fun'] = null;
    delete window['printRecord_index_fun'];
</script>

