<%@ page language="java" contentType="text/html;charset=UTF-8" pageEncoding="UTF-8" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="shiro" uri="http://shiro.apache.org/tags" %>
<%@ taglib prefix="cui" tagdir="/WEB-INF/tags" %>
<c:set var="ctx" value="${pageContext.request.contextPath}"/>
<%
    pageContext.setAttribute("idSuffix", String.valueOf(System.currentTimeMillis()).substring(6));
%>
<cui:layout id="layout${idSuffix}" fit="true">
    <cui:layoutRegion region="center">
        <cui:form id="form${idSuffix}" heightStyle="fill" style="padding: 0px;">
            <div style="width: 100%; margin: 0px auto;">
                <div class="form-wrap2" style="width: 100%;">
                    <table class="form-table" cellpadding="0" cellspacing="0">
                        <tr>
                            <td colspan="1">审批结果:</td>
                            <td colspan="4"><cui:radiolist id="status" componentCls="radio-md" repeatLayout="flow"
                                                           readonly="false" column="2" name="status"
                                                           data="radiolistdata"></cui:radiolist>
                            </td>
                        </tr>
                        <tr>
                            <td colspan="1">审批内容:</td>
                            <td colspan="4"><cui:textarea width="400" id="approvedText" name="approvedText"
                                                          height="100" required="true"></cui:textarea></td>
                        </tr>

                        <tr>
                            <td colspan="1">附件查看:</td>
                            <td colspan="4">
                                <div id="fileList${idSuffix}"
                                     style="height: 101px;overflow: auto;background-color: #ffffff;margin: 2px;border: 1px solid #bdd0e6;width:400px">
                                </div>
                            </td>
                        </tr>
                    </table>
                </div>
            </div>
        </cui:form>
    </cui:layoutRegion>
    <cui:layoutRegion region="south" style="overflow: hidden;">
        <div class="buttens-foot-tools">
            <a onclick="re_print_apply_sample.commitThis()">提交</a>
            <a onclick="re_print_apply_sample.colseD()">返回</a>
        </div>
    </cui:layoutRegion>
</cui:layout>
<script type="text/javascript">
    var radiolistdata = [{value: "1", text: "同意", checked: true},
        {value: "-1", text: "拒绝"}
    ];
    var re_print_apply_fun = (function (win, $) {
        function sample() {
        }

        var $thisDialog = $('#layout${idSuffix}').closest('.ctrl-init-dialog');
        var $form = $('#form${idSuffix}');
        $(function () {
            reloadAttachment();
        });


        //关闭
        sample.prototype.colseD = function () {
            closeThisDialog();
        }


        function closeThisDialog() {
            $thisDialog.dialog('close');
        }


        //提交
        sample.prototype.commitThis = function () {
            debugger;
            var formData = $form.form('formData')
            $.confirm(
                {
                    message: "请确认信息", callback: function (r) {
                        if (r) {
                            $.ajax({
                                type: 'GET',
                                url: '${ctx}/re-print-apply/updateRePrintStatus?id=${id}',
                                dataType: 'json',
                                data: formData,
                                success: function (data) {
                                    if (data) {
                                        rePrintResponse_index_sample.reloadGrid();
                                        closeThisDialog();
                                        $.messageToast("提交成功");

                                    }
                                }
                            });
                        } else {


                        }
                    }
                }
            )
            ;
        }

        //加载附件
        function reloadAttachment() {
            $.ajax({
                type: 'GET',
                url: '${ctx}/re-print-apply/loadAttach/${reAttachmentId}',
                dataType: 'json',
                success: function (data) {
                    debugger;
                    //hide();
                    if (${type eq 'apply'}) {
                        var hh = '<div class="fileItem" id="upload-' + data.id + '">' +
                            '<a href="#" style="text-decoration:line-through;color: darkgrey;" >' + data.name + '</a></div>'
                    } else {
                        var hh = '<div class="fileItem" id="upload-' + data.id + '">' +
                            '<a href="${ctx}/attachment/downloadOriginal/' + data.id + ' " target="_blank">' + data.name + '</a></div>'

                    }

                    $('#fileList${idSuffix}').html(hh);
                },
                error: function (e) {
                    //hide();
                    error(e);
                }
            });
        }

        return sample;
    })(window, $);

    var re_print_apply_sample = new re_print_apply_fun();
    window['re_print_apply_fun'] = null;
    delete window['re_print_apply_fun'];
</script>
