<%--
  since: 2019/7/8 22:01
  author: shen.shaohua
  description: 单位选取
  url: ${ctx}/auth/selectDept
--%>
<%@ page contentType="text/html;charset=UTF-8" pageEncoding="UTF-8" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="cui" tagdir="/WEB-INF/tags" %>
<c:set var="ctx" value="${pageContext.request.contextPath}"/>
<%
  pageContext.setAttribute("idSuffix", String.valueOf(System.currentTimeMillis()).substring(6));
%>
<style type="text/css">
  .se-searchall {
    position: relative;
    padding: 2px 0px 2px 4px;
  }

  .se-searchall .coral-corner-all {
    border-radius: 15px;
    border: 2px solid #dfdfdf;
  }

  .se-searchall .coral-textbox-default {
    padding: 5px 30px 5px 7px;
    height: auto;
  }

  .search-Click {
    position: absolute;
    right: 0px;
    top: 2px;
    width: 30px;
    height: 27px;
    border-radius: 0 15px 15px 0;
    line-height: 27px;
    color: #3686e8;
    text-indent: 4px;
    cursor: pointer;
  }

  .search-Click:hover {
    color: #2062B3;
  }
  .depart-selected-main {
    border: 1px solid #999999;
    height: 440px;
    /*overflow:scroll;*/
    overflow-y: auto;//竖直方向有滚动条，如果想要横向的，可以把y改为x
  }
</style>
<div id="selectDept${idSuffix}" class="wrap">
  <div class="depart-unselected">
    <div style="margin-bottom: 5px;">单位选取：</div>
    <div style="border: 1px solid #999999;overflow: auto;height: 477px;">
      <div class="se-searchall" style="width: 180px;">
      <cui:input type="text" id="left_orgTree_searchText${idSuffix}" placeholder="搜索" width="180" onEnter="auth_selectDept_sample.orgTreeSearch()"/>
      <span class="icon icon-search3 search-Click" onclick="auth_selectDept_sample.orgTreeSearch()"></span>
      </div>
      <cui:tree id="orgTree${idSuffix}" asyncUrl="${ctx}/auth/orgStampTreeData"
                asyncEnable="true" asyncType="post" asyncAutoParam="id,name"
                simpleDataEnable="true" simpleDataIdKey="id" simpleDataPIdKey="parentId"
                onClick="auth_selectDept_sample.treeOnClick"/>
    </div>
  </div>
  <div class="depart-selected">
    <div style="margin-bottom: 5px;color:#387ac6;">已选取<span id="yxsl${idSuffix}">0</span>个单位：</div>
    <%--<div class="depart-selected-main" style="overflow:scroll"> --%>
    <div class="depart-selected-main" id="message-box">
      <ul id="yxdw${idSuffix}">
        <!--<li>人大办公室</li>
        <li>政协办公室</li>-->
      </ul>
    </div>
    <div style="margin-top: 10px;">
      <cui:button componentCls="btn-primary" label="确定" onClick="auth_selectDept_sample.sure()"/>
      <cui:button componentCls="btn-primary" label="删除" onClick="auth_selectDept_sample.del()"/>
      <cui:button componentCls="btn-primary" label="清空" onClick="auth_selectDept_sample.clear()"/>
      <cui:button componentCls="btn-primary" label="保存自定义组" onClick="auth_selectDept_sample.saveGroup()"/>
    </div>
  </div>
</div>
<cui:dialog id="dialogZ${idSuffix}" modal="true" autoOpen="false" resizable="true"
            autoDestroy="true" reLoadOnOpen="true" maximized="false"></cui:dialog>
<script type="text/javascript">
  var auth_selectDept_fun = (function (win, $) {
    function sample() {
    }

    var $thisDialog = $('#selectDept${idSuffix}').closest('.ctrl-init-dialog');
    var $tree = $('#orgTree${idSuffix}');
    var $yxdw = $('#yxdw${idSuffix}');
    var selectDeptArray = [];
    var num = 0;
    $(function () {
      initLoad();//注意各方法的顺序
      yxdwLi();
    });

    //确定
    sample.prototype.sure = function () {
      <c:if test="${not empty param.callback}">
      //回调方法
      ${param.callback}(selectDeptArray);
      </c:if>
      closeThisDialog();
    }

    //关闭
    sample.prototype.colseD = function () {
      closeThisDialog();
    }

    sample.prototype.reloadTree = function () {
      $tree.tree('reload');
    }

    //组织树查询
    sample.prototype.orgTreeSearch = function () {
      var searchName = $('#left_orgTree_searchText${idSuffix}').val();
      $tree.tree('option', 'asyncOtherParam', ['searchName', searchName]);
      $tree.tree('reload');
    }

    function closeThisDialog() {
      $thisDialog.dialog('close');
    }

    function initLoad() {
      //var deptArray = JSON.parse(localStorage.getItem('str'));
      var deptArray = null;
      <c:if test="${not empty param.initfun}">
      deptArray = ${param.initfun}();
      </c:if>
      //console.log(deptArray)
      if (deptArray != null && deptArray.length > 0) {
        for (var i = 0; i < deptArray.length; i++) {
          var hh = '';
          hh = '<li data-id="' + deptArray[i].deptId + '">' + deptArray[i].deptName + '</li>';
          $yxdw.append(hh);
          num++;
          selectDeptArray.push({
              num:num,
            deptId: deptArray[i].deptId,
            deptName: deptArray[i].deptName
          });
        }
      }
    }

    //已选单位点击事件刷新
    function yxdwLi() {
        $('#message-box')[0].scrollTop =$('#message-box')[0].scrollHeight;
      $yxdw.find('li').unbind('click').click(function () {
        $(this).toggleClass('active');
      });
      yxsl();
    }

    //刷新已选数量
    function yxsl() {
      $('#yxsl${idSuffix}').html($yxdw.find('li').length);
    }

    //树节点点击事件
    sample.prototype.treeOnClick = function (event, id, treeNode) {
      /*
      console.log('event', event);
      console.log('id', id);
      */
      console.log('treeNode', treeNode);
      if (treeNode.type == 'orgRoot' || treeNode.type == 'groupRoot') { //组织部门根节点/自定义组根节点
          console.log('组织部门根节点||自定义组根节点');
        var nodes1 = [treeNode];
        hd(nodes1);
        yxdwLi();
        return;
      }
      var nodes = [];
      if (treeNode.type == 'org') { //组织节点
        if (treeNode.children && treeNode.children.length > 0) {
          //nodes = nodes.concat(treeNode.children);
          nodes = treeNode.children;
        } else {
          nodes = [treeNode];
        }
      } else if (treeNode.type == 'group') { //自定义组
        nodes = treeNode.children;
      } else if (treeNode.type == 'groupElement') { //自定义组成员
        nodes = [treeNode];
      }
      //console.log("nodes", nodes);
      for (var i = 0; i < nodes.length; i++) {
        var node = nodes[i];
        var isExist = false;
        $.each(selectDeptArray, function (i, item) {
          if (item.deptId == node.deptId) {
            isExist = true;
            return false;
          }
        });
        if (isExist) {
            console.log("存在，选中节点==>",node);
            //如果存在弹窗提示，第一个存在的单位之后的就不添加
            setTimeout(function () {
                alert(node.name+"已存在！");
            },100)
            return;
          //continue;
        }
        num++;
        selectDeptArray.push({
          num:num,
          deptId: node.deptId,
          deptName: node.name
        });
        var hh = '';
        hh += '<li data-id="' + node.deptId + '">' + node.name + '</li>';
        $yxdw.append(hh);

      }
      yxdwLi();
    }

    //遍历所有子节点，点击根目录选中所有子节点
    function hd(nodes) {
        console.log("选中节点==>",nodes);
      for (var i = 0; i < nodes.length; i++) {
        var treeNode = nodes[i];
        //alert(treeNode.isParent)
        if (treeNode.isParent) {
          hd(treeNode.children);
        } else {
          if (treeNode.type != 'groupRoot') {
            var isExist = false;
            $.each(selectDeptArray, function (i, item) {
              if (item.deptId == treeNode.deptId) {
                isExist = true;
                return false;
              }
            });
            if (!isExist) {
                console.log("不存在，选中节点==>",treeNode);
              selectDeptArray.push({
                deptId: treeNode.deptId,
                deptName: treeNode.name
              });
              var hh = '';
              hh += '<li data-id="' + treeNode.deptId + '">' + treeNode.name + '</li>';
              $yxdw.append(hh);
            }/*else {
                console.log("存在，选中节点==>",treeNode);
                //如果存在弹窗提示，第一个存在的单位之后的就不添加
                alert(treeNode.name+"已存在！");
                return;

            }*/
          }
        }
      }
    }

    //清空
    sample.prototype.clear = function () {
      $yxdw.empty();
      selectDeptArray = [];
      yxsl();
    }

    //删除
    sample.prototype.del = function () {
      var $lis = $yxdw.find('li.active');
      $lis.each(function () {
        var deptId = $(this).data('id');
        $.each(selectDeptArray, function (i, item) {
          if (item.deptId == deptId) {
            selectDeptArray.splice(i, 1);
            return false;
          }
        });
      });
      $lis.remove();
      yxsl();
    }

    //保存自定义组
    sample.prototype.saveGroup = function () {
      if (selectDeptArray == null || selectDeptArray.length == 0) {
        warning('请先选择单位部门！');
        return;
      }
      var url = '${ctx}/selfDefindeGroup/add?onloadFun=auth_selectDept_sample.zdydw';
      $('#dialogZ${idSuffix}').dialog('option', {
        url: url,
        title: '添加单位',
        asyncType: 'get',
        width: 480,
        height: 280,
        buttons: null
      }).dialog('open');
    }

    //获取已选单位
    sample.prototype.zdydw = function () {
      return selectDeptArray;
    }

    return sample;
  })(window, $);

  var auth_selectDept_sample = new auth_selectDept_fun();
  window['auth_selectDept_fun'] = null;
  delete window['auth_selectDept_fun'];
</script>
