<%@ page language="java" contentType="text/html;charset=UTF-8" pageEncoding="UTF-8" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="shiro" uri="http://shiro.apache.org/tags" %>
<%@ taglib prefix="cui" tagdir="/WEB-INF/tags" %>
<c:set var="ctx" value="${pageContext.request.contextPath}"/>
<%
    pageContext.setAttribute("idSuffix", String.valueOf(System.currentTimeMillis()).substring(6));
%>
<div style="height: 100%;">
    <div class="nav2"><img src="${ctx}/static/cm/image/fjj-nav.png"/>用章管理</div>
    <div class="table-head">
        <div class="table-title">用章管理列表</div>
    </div>
    <cui:form id="searchForm${idSuffix}" style="margin: 0px;padding: 0px;">
        <div style="text-align: center;padding: 5px 7px 10px 6px;">
            <span class="btn-bar">
                <cui:radio id="radio3" name="type" value="1" onClick='mailSend_list_sample.jsdwType1()' label="我的用章"/><span id="wdCount" style="margin-left: -10px" ></span>
                <cui:radio id="radio4" name="type" value="2" onClick='mailSend_list_sample.jsdwType1()' label="用章处理" checked="true"/><span id="yzCount" style="margin-left: -10px"></span>
            </span>
            <span style="padding-left: 20px">标题:</span>
            <cui:input type="text" name="mailTitle" id="mailTitle${idSuffix}" width="120" required="false"/>
            <span style="padding-left: 20px;">申请时间:</span>
            <cui:datepicker width="120" name="sendTimeStart" dateFormat="yyyy-MM-dd"/>
            至
            <cui:datepicker width="120" name="sendTimeEnd" dateFormat="yyyy-MM-dd"/>
            <span style="padding-left: 20px;">状态:</span>
            <cui:combobox name="status" id="status${idSuffix}" readonlyInput="false"
                          width="120" data="mailSend_list_sample.statusData" emptyText="请选择" value="0"/>
            <span class="btn-bar">
          <a onclick="mailSend_list_sample.search()" id="search${idSuffix}">查询</a>
          <a onclick="mailSend_list_sample.del()" style="display: none" id="del${idSuffix}">删除</a>
        </span>
        </div>
    </cui:form>
    <cui:grid id="grid${idSuffix}" url="${ctx}/stamp/stampQueryApplyList" asyncType="get"
              postData="mailSend_list_sample.postData"
              sortorder="desc" loadonce="false" rownumbers="true" fitStyle="fill" multiselect="true"
              style="margin-left: 5px;margin-right: 5px;">
        <cui:gridCols>
            <cui:gridCol hidden="true" name="hpId">hpId</cui:gridCol>
            <cui:gridCol hidden="true" name="mailSendId">mailSendId</cui:gridCol>
            <cui:gridCol hidden="true" name="stId">stId</cui:gridCol>
            <cui:gridCol hidden="true" name="execId" >execId</cui:gridCol>
            <cui:gridCol hidden="true" name="mailSendId" >mailSendId</cui:gridCol>
            <cui:gridCol hidden="true" name="nodeCode" >nodeCode</cui:gridCol>
            <cui:gridCol hidden="true" name="preNodeId" >preNodeId</cui:gridCol>
            <cui:gridCol align="center" name="mailTitle" formatter="mailSend_list_sample.titleFmt" width="40">标题</cui:gridCol>
            <cui:gridCol align="center" name="startTime" width="30" dataType="hideCol" hidden="true">申请时间</cui:gridCol>
            <cui:gridCol align="center" name="assgineeName" width="15" dataType="hideCol" hidden="true" formatter="mailSend_list_sample.assgineeNameFmt">当前处理人</cui:gridCol>
            <cui:gridCol align="center" name="assgineeOrgId" width="30" dataType="hideCol" hidden="true" formatter="mailSend_list_sample.orgFmt">当前处理部门</cui:gridCol>
            <cui:gridCol align="center" name="applyDeptName" width="15" dataType="hideCol">申请部门</cui:gridCol>
            <cui:gridCol align="center" name="file" formatter="mailSend_list_sample.fileFmt" width="15">电子文件</cui:gridCol>
            <cui:gridCol align="center" name="phStatus" formatter="mailSend_list_sample.statusFmt" width="15">状态</cui:gridCol>
            <cui:gridCol align="center" name="stStatus" width="15" hidden="true">状态</cui:gridCol>
        </cui:gridCols>
        <cui:gridPager gridId="grid${idSuffix}"/>
    </cui:grid>
</div>
<cui:dialog id="dialogA${idSuffix}" modal="true" autoOpen="false" reLoadOnOpen="true"
            focusInput="false" resizable="true" autoDestroy="true" maximized="false"></cui:dialog>
<script type="text/javascript">
    var mailSend_list_fun = (function (win, $) {
        function sample() {
            this.postData = {
                orderBy: 'STATUS@asc,SEND_TIME@desc',
                status: '0'
            }
            this.statusData = [
                    {text: '未处理', value: '0', selected:true},
                    {text: '已处理', value: '1'}
                    ]
        }
        var $grid = $('#grid${idSuffix}');

            $.ajax({
                type: 'GET',
                url: '${ctx}/stamp/counts',
                async: false,
                dataType: 'json',
                success: function (data) {
                    if (data.wdCount==0){
                        $('#wdCount').html("");
                    }else {
                        $('#wdCount').html("(未完成：<span style=\"color: red\">"+data.wdCount+"</span>件)");
                    }
                    if (data.yzCount==0){
                        $('#yzCount').html("");
                    }else {
                        $('#yzCount').html("(未完成：<span style=\"color: red\">"+data.yzCount+"</span>件)");
                    }
                },
                error: function (e) {
                    //hide();
                    error(e);
                }
            });

        sample.prototype.radioFmt = function(){
            $("#zddj").trigger("click")
        }
        sample.prototype.orgFmt = function (cellValue, options, rowObject) {
            var result = '';
            $.ajax({
                type: 'GET',
                url: '${ctx}/stamp/orgName',
                data: {orgId:rowObject.assgineeOrgId},
                async: false,
                dataType: 'json',
                success: function (data) {
                    if (rowObject.nodeCode!="end"){
                        result=data.name;
                    }
                },
                error: function (e) {
                    //hide();
                    error(e);
                }
            });
            return result;
        }
        sample.prototype.assgineeNameFmt = function (cellValue, options, rowObject) {
            var result = '';
            if (rowObject.nodeCode!="end"){
                result=rowObject.assgineeName;
            }
            return result;
        }
        sample.prototype.fileFmt = function (cellValue, options, rowObject) {
            var hh = '';
            $.ajax({
                type: 'GET',
                url: '${ctx}/attachment/find/mail/' + rowObject.mailSendId,
                async: false,
                dataType: 'json',
                success: function (data) {
                    //hide();

                    $.each(data, function (i, item) {
                        var securityLevelFileText = "";
                        if(item.securityLevelFile!=null){
                            securityLevelFileText = '('+item.securityLevelFile+')';
                        }
                        var securityLevel = "(无)";
                        if(!isEmpty($("#safeLevel${idSuffix}").text())){
                            securityLevel = '('+ $("#safeLevel${idSuffix}").text()+')';
                        }
                        if(item.securityLevelFile!=null){
                            hh += '<div class="fileItem" id="upload-' + item.id + '">' +
                                '<a onclick="mailSend_list_sample.printAttachment(\'' + item.id + '\')" target="_blank">' + item.name.split(".")[0] + securityLevelFileText  + '</a>' +
                                '</div>'
                        }else{
                            hh += '<div class="fileItem" id="upload-' + item.id + '">' +
                                '<a onclick="mailSend_list_sample.printAttachment(\'' + item.id + '\')" target="_blank">' + item.name.split(".")[0] + securityLevel + '</a>' +
                                '</div>'
                        }

                    });
                },
                error: function (e) {
                    //hide();
                    error(e);
                }
            });
            return hh;
        }
        //选择类型
        sample.prototype.jsdwType1 = function () {
            if ($("#radio3" ).radio( "getValues" )=="1"){
                $( "#status${idSuffix}" ).combobox( "reload", [
                    {text: '待送审', value: '2'},
                    {text: '被退回', value: '3'},
                    {text: '待审核', value: '4'},
                    {text: '待盖章', value: '5'},
                    {text: '未完成', value: '7',selected:true},
                    {text: '待确认', value: '8'},
                    {text: '已完成', value: '6'},
                ]);
            }else {
                $( "#status${idSuffix}" ).combobox( "reload", [
                    {text: '未处理', value: '0',selected:true},
                    {text: '已处理', value: '1'}
                ]);
            }
            console.log("开始查询！")
            var $form = $('#searchForm${idSuffix}');
            var formData = $form.form('formData');
            if (formData.sendTimeStart) formData.sendTimeStart = formData.sendTimeStart + '00:00:00';
            if (formData.sendTimeEnd) formData.sendTimeEnd = formData.sendTimeEnd + '23:59:59';
            this.postData = $.extend(this.postData, formData);
            $grid.grid('reload', {page: 1});
            if ($("#radio3" ).radio( "getValues" )=="1"){
                $grid.grid( "showCol", "assgineeName" );
                $grid.grid( "showCol", "assgineeOrgId" );
                $grid.grid( "showCol", "stStatus" );
                $grid.grid( "showCol", "startTime" );
                $grid.grid( "hideCol", "phStatus" );
                $grid.grid( "hideCol", "applyDeptName" );
                $("#del${idSuffix}").removeAttr("style")
            }else {
                $grid.grid( "hideCol", "assgineeName" );
                $grid.grid( "hideCol", "assgineeOrgId" );
                $grid.grid( "hideCol", "stStatus" );
                $grid.grid( "hideCol", "startTime" );
                $grid.grid( "showCol", "phStatus" );
                $grid.grid( "showCol", "applyDeptName" );
                $("#del${idSuffix}").attr("style","display:none")
            }
        }
        //判断字符是否为空的方法
        function isEmpty(obj) {
            if (typeof obj == "undefined" || obj == null || obj == "") {
                return true;
            } else {
                return false;
            }
        }
        //点击电子文件
        sample.prototype.printAttachment = function (attachId) {
            var url = '${ctx}/print-num/updatePrintNum3?attachId=' + attachId;
            window.open(url);
        }
        sample.prototype.statusFmt = function (cellValue, options, rowObject) {
            var result = '';
            var status = rowObject.phStatus;
            var nodeCode = rowObject.nodeCode;
            var hpId = rowObject.hpId;
            var preNodeId = rowObject.preNodeId;
            if (status == 'completed') {
                if (nodeCode=='bdwgzgly'||nodeCode=='wdwgzgly'){
                    result = '已盖章';
                }else if (nodeCode=='bdwldsp'||nodeCode=='wdwldsp'){
                    //领导退回状态判断，根据hpid和apply节点标志查询数据库是否有符合数据
                    $.ajax({
                        type: 'GET',
                        url: '${ctx}/stamp/selectByhpIdDwld/' + hpId,
                        async: false,
                        dataType: 'json',
                        success: function (data) {
                            if (data.status!='0'){
                                result = '完成（已退回）';
                            }else {
                                result = '已审核';
                            }
                        },
                        error: function (e) {
                            hide();
                            error(e);
                        }
                    });
                }else if (nodeCode=='wdwjsy'){
                    result = '已送审'
                }else if (nodeCode=='apply'){
                    result = '已送审'
                }else if (nodeCode=='dqr'){
                    result = '已确认'
                }
            } else if (status == 'signed'||status == null) {
                if (nodeCode=='bdwgzgly'||nodeCode=='wdwgzgly'){
                    result = '待盖章';
                }else if (nodeCode=='bdwldsp'||nodeCode=='wdwldsp'){
                    result = '待审核';
                }else if (nodeCode=='wdwjsy'){
                    result = '待送审'
                }else if (nodeCode=='dqr'){
                    result = '待确认'
                }else if (nodeCode=='apply'){
                    //申请人退回状态判断，
                    $.ajax({
                        type: 'GET',
                        url: '${ctx}/stamp/selectByhpIdApply/' + preNodeId,
                        async: false,
                        dataType: 'json',
                        success: function (data) {
                            if (data.status!='0'){
                                result = '待送审';
                            }else {
                                result = '待送审（退回）';
                            }
                        },
                        error: function (e) {
                            hide();
                            error(e);
                        }
                    });
                }
            } else {
                result = status;
            }
            return result;
        }

        //查询
        sample.prototype.search = function () {
            console.log("开始查询！")
            var $form = $('#searchForm${idSuffix}');
            var formData = $form.form('formData');
            if (formData.sendTimeStart) formData.sendTimeStart = formData.sendTimeStart;
            if (formData.sendTimeEnd) formData.sendTimeEnd = formData.sendTimeEnd;
            this.postData = $.extend(this.postData, formData);
            $grid.grid('reload', {page: 1});
        }

        //添加
        /*sample.prototype.add = function () {
            var url = '${ctx}/mail-send/add';
            $('#dialogA${idSuffix}').dialog('option', {
                url: url,
                title: '添加发文',
                asyncType: 'get',
                width: 1000,
                height: 550,
                buttons: null
            }).dialog('open');
        }*/

        //删除
        sample.prototype.del = function () {
            var selrows = $grid.grid('option', 'selarrrow');
            if (selrows.length < 1) {
                warning('请选择要删除的记录！');
                return;
            }
            var ids = [];
            for (var i = 0; i < selrows.length; i++) {
                var rowData = $grid.grid('getRowData', selrows[i]);
                if (rowData.nodeCode=="end"){
                    warning('所选数据中有已完成的数据,不能删除！');
                    return;
                }
                ids.push(rowData.stId);
            }
            $.confirm('将同时删除相关信息<br>确定要删除吗？', function (r) {
                if (r) {
                    loading('删除中...');
                    $.ajax({
                        type: 'DELETE',
                        url: '${ctx}/stamp/deleteStampAndPHis',
                        data: {
                            stampIds: ids.join(',')
                        },
                        dataType: 'json',
                        success: function (data) {
                            hide();
                            if (data == true) {
                                message('删除成功！');
                            }
                            $grid.grid('reload');
                        },
                        error: function (e) {
                            hide();
                            error(e);
                        }
                    });
                }
            });
        }

        //刷新列表
        sample.prototype.reloadGrid = function () {
            $grid.grid('reload');
        }
        //点击标题
        sample.prototype.titleFmt = function (cellValue, options, rowObject) {
            var result = '<a onclick="mailSend_list_sample.edit(\''+rowObject.execId+'\',\''+rowObject.stId+'\',\''+rowObject.mailSendId+'\')">' + cellValue + '</a>';
            return result;
        }

        //查看
        sample.prototype.edit = function (execId,stId,mailSendId) {
            var url = '${ctx}/stamp/editStamp/' + execId +'/' + stId +'/' + mailSendId;
            $('#dialogA${idSuffix}').dialog('option', {
                url: url,
                title: '用章表',
                asyncType: 'get',
                width: 1500,
                height: 700,
                buttons: null
            }).dialog('open');
            //window.open(url);
        }

        //用章
        sample.prototype.stamp = function () {
            console.log("用章！")
            var selrows = $grid.grid('option', 'selarrrow');
            if (selrows.length != 1) {
                warning('请选择一条要用章的记录！');
                return;
            }
            var ids = [];
            for (var i = 0; i < selrows.length; i++) {
                var rowData = $grid.grid('getRowData', selrows[i]);
                ids.push(rowData.id);
            }
            var id=ids[0];
            var url = '${ctx}/mail-send/editStamp/' + id;
            $('#dialogA${idSuffix}').dialog('option', {
                url: url,
                title: '用章',
                asyncType: 'get',
                width: 1000,
                height: 550,
                buttons: null
            }).dialog('open');
        }

        return sample;
    })(window, $);

    var mailSend_list_sample = new mailSend_list_fun();
    window['mailSend_list_fun'] = null;
    delete window['mailSend_list_fun'];
</script>
